# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from twisted.internet import reactor
from twisted.conch.ssh import transport, filetransfer, common
from twisted.conch.ssh import transport, common
from twisted.python import failure

import gtk, gobject
import os, pwd, getpass, exceptions, time

#import filetransfer
import Conf, FileTransfer, __SSHClient__, Panel, Handler, func, \
	FileTransferQueue, __OS__, XMLHandler

import __VEE__, WIDGET

class SSH (__VEE__.Core, WIDGET.WIDGET) :

	KWARGS = dict()
	SETTING = dict()

	HANDLER_ID_CONNECT = None
	CONNECTION = None
	CONF = None
	FT = None
	CURRENT_DIRECTORY_REMOTE = None
	CURRENT_DIRECTORY_LOCAL = None

	DIRECTORY_HISTORY_REMOTE = list()
	DIRECTORY_HISTORY_LOCAL = list()

	FILE_TRANSFER = None
	FILETRANSFERQUEUE = None

	ENTRY_LOG_MESSAGE = None

	def __init__ (self, **kwargs) :
		self.KWARGS = kwargs

		__VEE__.Core.__init__(self, **kwargs)

		self.SHORTCUT_LOCAL = self.STATE_GLOBAL["shortcut-local"]
		self.FILE_TRANSFER = FileTransfer.FileTransfer(self)
		self.FILETRANSFERQUEUE = FileTransferQueue.SSH(self)

		WIDGET.WIDGET.__init__(self, "vbox_ssh_filebrowser")
		self.__initialize(**kwargs)

		# connect or not.
		if self.KWARGS.has_key("setting") and \
				self.KWARGS["setting"].has_key("file-uid") :
			self.SETTING = self.KWARGS["setting"]

			if not __OS__.is_file(self.SETTING["file-uid"]) :
				raise RuntimeError, "file-uid must be indicated as file."

			self.on_connect()

	def __del__ (self) :
		self.__disconnect()

	def __initialize (self, **kwargs) :

		__button_connect = self.getWidget("toggletoolbutton_connect")
		self.HANDLER_ID_CONNECT = \
			__button_connect.connect("toggled", self.on_connect)

		self.PANEL_LOCAL = Panel.FileListLocal(self.xml)
		self.PANEL_LOCAL.FILE_TRANSFER = self

		self.PANEL_TREE_LOCAL = Panel.TreeLocal(self.xml)
		self.PANEL_TREE_LOCAL.FILE_TRANSFER = self

		self.PANEL_REMOTE = Panel.FileListRemote(self.xml)
		self.PANEL_REMOTE.FILE_TRANSFER = self

		self.PANEL_TREE_REMOTE = Panel.TreeRemote(self.xml)
		self.PANEL_TREE_REMOTE.FILE_TRANSFER = self

		self.PANEL_SHORTCUT_LOCAL = Panel.ShortcutLocal(self.xml, self, **kwargs)

		# initiate filetransferQueue

		self.PANEL_FILETRANSFER_STATUS = \
			Panel.FileTransferStatus(self.xml, self.FILETRANSFERQUEUE, self)

		self.getWidget("box_remote").set_property("sensitive", False)

		self.getWidget("box_tree_local").set_property("visible", True)
		self.getWidget("box_shortcut_local").set_property("visible", False)
		self.getWidget("box_tree_remote").set_property("visible", True)
		self.getWidget("box_shortcut_remote").set_property("visible", False)

		self.getWidget("toggletoolbutton4").set_active( \
			self.getWidget("box_shortcut_local").get_property("visible"))

		self.getWidget("toggletoolbutton2").set_active( \
			self.getWidget("box_shortcut_remote").get_property("visible"))

		self.CURRENT_DIRECTORY_LOCAL = pwd.getpwnam(getpass.getuser())[5]
		self.listAllLocal(os.curdir)

		(w, h, ) = self.WIDGET_SELF.get_root_window().get_size()
		self.getWidget("hpaned1").set_position(w / 2)

		self.ENTRY_LOG_MESSAGE = self.getWidget("label_log_message")

		gobject.timeout_add(1000*3, self.__eraseLogMessage)

		# connect handlers.
		#self.connect_handler(Handler.SSH_FILEBROWSER)

	##################################################
	# EVENT HANDLER
	def on_clean_up_file_transfer_status (self, widget) :
		self.PANEL_FILETRANSFER_STATUS.clear()

	def on_toggle_tree_and_shortcut_local (self, widget) :
		self.getWidget("box_tree_local").set_property( \
			"visible", \
			not self.getWidget("box_tree_local").get_property("visible") \
		)
		self.getWidget("box_shortcut_local").set_property( \
			"visible", \
			not self.getWidget("box_tree_local").get_property("visible") \
		)

	def on_toggle_tree_and_shortcut_remote (self, widget) :
		self.getWidget("box_tree_remote").set_property( \
			"visible", \
			not self.getWidget("box_tree_remote").get_property("visible") \
		)
		self.getWidget("box_shortcut_remote").set_property( \
			"visible", \
			not self.getWidget("box_tree_remote").get_property("visible") \
		)

	def on_connect (self, widget=None) :
		__button_connect = self.getWidget("toggletoolbutton_connect")
		__is_connected = self.isConnected()

		if __is_connected :
			self.__disconnect()
			__button_connect.set_label("Connect")
			self.getWidget("box_remote").set_property("sensitive", False)
		else :
			self.__connect()
			__button_connect.set_label("Disconnect")
			self.getWidget("box_remote").set_property("sensitive", True)

		# update the 'active' state of togglebutton
		if self.HANDLER_ID_CONNECT :
			__button_connect.handler_block(self.HANDLER_ID_CONNECT)
			__button_connect.set_active(not __is_connected)
			__button_connect.handler_unblock(self.HANDLER_ID_CONNECT)

	def on_stop_transfer (self, widget) :
		__uids = self.PANEL_FILETRANSFER_STATUS.getCurrentSelectedUID()
		for i in __uids :
			self.FILETRANSFERQUEUE.stop(i)

		self.FILETRANSFERQUEUE.next()

	#######################################################
	# LOCAL EVENT
	def on_directory_new_local (self, widget) :
		__name = \
			__OS__.get_new_directory_name(os.listdir(self.CURRENT_DIRECTORY_LOCAL))

		__new_filepath = os.path.join(self.CURRENT_DIRECTORY_LOCAL, __name)
		__ret = __OS__.mkdir(__new_filepath)
		if __ret is not True :
			if __ret == __OS__.ERROR_FILE_ALREADY_EXISTS :
				func.format_log_string( \
					self.ENTRY_LOG_MESSAGE, _("ERROR_FILE_ALREADY_EXISTS"))
			elif __ret == __OS__.ERROR_NO_PERMISSION :
				func.format_log_string( \
					self.ENTRY_LOG_MESSAGE, _("ERROR_NO_PERMISSION"))
			elif __ret == __OS__.IOError :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("IOError"))
			else :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("Failed"))

			return False

		__iter = \
			self.PANEL_LOCAL.addRow( \
				[__new_filepath] + list(os.stat(__new_filepath)) \
			)
		self.PANEL_LOCAL.set_editable(__iter)

	def on_directory_home_local (self, widget) :
		self.listAllLocal(pwd.getpwnam(getpass.getuser())[5])

	def on_directory_up_local (self, widget) :
		self.listAllLocal ( \
			os.path.normpath(os.path.join(self.CURRENT_DIRECTORY_LOCAL, "../")) \
		)

	def on_refresh_list_all_local (self, widget) :
		self.listAllLocal()

	def on_done_directory_entry_local (self, widget, event) :
		if func.get_keyname(event) != "Return" :
			return
		else :
			__path = widget.get_text()
			self.listAllLocal(__path)

	#######################################################
	# REMOTE EVENT
	def on_directory_new_remote (self, widget) :
		path = self.getRealPathRemote(self.CURRENT_DIRECTORY_REMOTE)

		d = self.FILE_TRANSFER.cmd_LS(path)
		d.addCallback(self.__cb_on_directory_new_remote, path)
		d.addErrback(self.errBackRemote, "create new directory")

	def __cb_on_directory_new_remote (self, result, path) :
		
		__name = __OS__.get_new_directory_name([i[0] for i in result])

		__new_filepath = os.path.join(self.CURRENT_DIRECTORY_REMOTE, __name)
		d = self.FILE_TRANSFER.cmd_MKDIR(__new_filepath)
		d.addCallback(self.__cb_on_directory_new_remote0, __new_filepath)
		d.addErrback(self.errBackRemote, "create new directory")

	def __cb_on_directory_new_remote0 (self, result, new_filepath) :
		d = self.FILE_TRANSFER.cmd_LS(new_filepath)
		d.addCallback(self.__cb_on_directory_new_remote1, new_filepath)
		d.addErrback(self.errBackRemote, "create new directory")

	def __cb_on_directory_new_remote1 (self, result, new_filepath) :
		if len(result) < 1 :
			return

		__iter = self.PANEL_REMOTE.addRow( \
			[os.path.basename(new_filepath), ] + list(result[0])[1:])

		self.PANEL_REMOTE.set_editable(__iter)

	def on_directory_home_remote (self, widget) :
		self.FILE_TRANSFER.TRANSFER.goHome()

	def on_directory_up_remote (self, widget) :
		self.listAllRemote ( \
			os.path.normpath(os.path.join(self.CURRENT_DIRECTORY_REMOTE, "../")) \
		)

	def on_refresh_list_all_remote (self, widget) :
		self.listAllRemote()

	def on_done_directory_entry_remote (self, widget, event) :
		if func.get_keyname(event) != "Return" :
			return
		else :
			__path = widget.get_text()
			self.listAllRemote(__path)

	##################################################
	# misc HANDLER
	def getRealPathLocal (self, path, isFile=False) :
		if not path : return self.CURRENT_DIRECTORY_LOCAL

		if not path.strip().startswith("/") :
			path = os.path.join(self.CURRENT_DIRECTORY_LOCAL, path.strip())

		if not isFile and not path.endswith('/') :
			path += '/'

		return os.path.normpath(path)

	def getRealPathRemote (self, path, isFile=False) :
		if not path : return ""
		if not path.strip().startswith("/") :
			path = os.path.join(self.CURRENT_DIRECTORY_REMOTE, path.strip())

		if not isFile and not path.endswith('/') :
			path += '/'

		return path

	def isConnected (self) :
		if self.CONNECTION :
			try :
				return self.CONF["filetransfer"].getClient().connected
			except :
				return False
		else :
			return False

	def __disconnect (self) :
		if self.CONNECTION :
			self.CONNECTION.transport.loseConnection()

			self.CONNECTION = None
			self.CONF = None

	CONF = dict()
	def __connect (self) :

		options = __SSHClient__.ClientOptions_Sftp()
		options.opt_uid(self.SETTING["file-uid"])

		self.CONF = { \
			"options" : options, \
			"filetransfer" : self.FILE_TRANSFER, \
		}

		options = self.CONF["options"]

		reactor.connectTCP( \
			options["host"], \
			options["port"], \
			__SSHClient__.SSHClientFactory(self.CONF, self) \
		)
		self.__loadShortcutRemote(options)
		self.PANEL_SHORTCUT_REMOTE = \
			Panel.ShortcutRemote(self.xml, self, **self.KWARGS)

	FILENAME_SHORTCUT_REMOTE = None
	def __loadShortcutRemote (self, options) :
		__hostid = "sftp_%s@%s" % (options["user"], options["host"])
		self.FILENAME_SHORTCUT_REMOTE = Conf.FILE_SHORTCUT_REMOTE % __hostid

		# shortcut
		try :
			__shortcut = XMLHandler.Shortcut(self.FILENAME_SHORTCUT_REMOTE)
		except IOError :
			__shortcut = XMLHandler.Shortcut()

		self.SHORTCUT_REMOTE = __shortcut

	##############################################################
	# LOCAL LISTING
	def listAllLocal (self, path=None) :
		path = self.getRealPathLocal(path)

		self.listFileLocal(path)
		self.listTreeLocal(os.path.normpath(os.path.join(path, "../")))

		return

	def listFileLocal (self, path=None) :
		path = self.getRealPathLocal(path)

		self.CURRENT_DIRECTORY_LOCAL = path

		__files = os.listdir(path)
		result = list()
		for i in __files :
			__filepath = os.path.join(path, i)
			result.append(tuple([__filepath, ] + list(os.stat(__filepath))))

		self.PANEL_LOCAL.clear()
		self.PANEL_LOCAL.addRows(result)

		__entry = self.getWidget("entry_directory_local")
		__entry.set_text(path)
		__entry.select_region(0, -1)

		"""
		os.stat returns,
			st_mode (protection bits)
			st_ino (inode number)
			st_dev (device)
			st_nlink (number of hard links)
			st_uid (user ID of owner)
			st_gid (group ID of owner)
			st_size (size of file in bytes)
			st_atime (time of most recent access)
			st_mtime (time of most recent content modification)
			st_ctime (time of most recent content modification or metadata change).
		"""

		return

	def listTreeLocal (self, path) :
		path = self.getRealPathLocal(path)

		__files = os.listdir(path)
		result = list()
		for i in __files :
			__filepath = os.path.join(path, i)
			result.append(tuple([__filepath, ] + list(os.stat(__filepath))))

		self.PANEL_TREE_LOCAL.clear()
		self.PANEL_TREE_LOCAL.addRows(result)

		return

	##############################################################
	# REMOTE LISTING
	def listFileRemote (self, path=None) :
		path = self.getRealPathRemote(path)

		d = self.FILE_TRANSFER.cmd_LS(path)
		d.addCallback(self.__listFileRemote, path)
		d.addErrback(self.errBackRemote, "listfile-remote")

		return

	def listAllRemote (self, path=None) :
		if not path : path = self.CURRENT_DIRECTORY_REMOTE

		self.listFileRemote(path)
		self.listTreeRemote(os.path.normpath(os.path.join(path, "../")))

	def listTreeRemote (self, path) :
		path = self.getRealPathRemote(path)

		d = self.FILE_TRANSFER.cmd_LS(path)
		d.addCallback(self.__listTreeRemote, path)
		d.addErrback(self.errBackRemote, "tree-remote")

		return

	def __listTreeRemote (self, result, path) :
		if not result : return

		self.PANEL_TREE_REMOTE.clear()
		self.PANEL_TREE_REMOTE.addRows(result)

	def __listFileRemote (self, result, path) :
		if not result : return
		#if path == self.CURRENT_DIRECTORY_REMOTE : return

		self.DIRECTORY_HISTORY_REMOTE.append(path)

		__entry = self.getWidget("entry_directory_remote")
		__entry.set_text(path)
		__entry.select_region(0, -1)

		self.CURRENT_DIRECTORY_REMOTE = path
		self.PANEL_REMOTE.clear()
		self.PANEL_REMOTE.addRows(result)

	def errBackLocal (self, retval, parm0=None) :

		if retval == __OS__.ERROR_OK :
			#func.format_log_string(self.ENTRY_LOG_MESSAGE, _("OK"))
			pass
		elif retval == __OS__.ERROR_FILE_ALREADY_EXISTS :
			func.format_log_string(self.ENTRY_LOG_MESSAGE, _("File or directory already exists."))
		elif retval == __OS__.ERROR_NO_PERMISSION :
			func.format_log_string(self.ENTRY_LOG_MESSAGE, _("No permission"))
		elif retval == __OS__.ERROR_IOERROR :
			func.format_log_string(self.ENTRY_LOG_MESSAGE, _("IO Error"))
		elif retval == __OS__.ERROR_NO_SUCH_FILE_OR_DIRECTORY :
			func.format_log_string(self.ENTRY_LOG_MESSAGE, \
				_("No such file or directory"))
		elif retval == __OS__.ERROR_DESTINATION_NO_SUCH_FILE_OR_DIRECTORY :
			func.format_log_string(self.ENTRY_LOG_MESSAGE, \
				_("No such file or directory"))
		elif retval == __OS__.ERROR_OS_ERROR :
			func.format_log_string(self.ENTRY_LOG_MESSAGE, _("OSError"))
		elif retval == __OS__.ERROR_DESTINATION_IS_FILE :
			func.format_log_string(self.ENTRY_LOG_MESSAGE, _("It is file."))
		else :
			func.format_log_string(self.ENTRY_LOG_MESSAGE, _("Failed."))

	def ignore (self, f, parm0=None) :
		pass

	def errBackRemote (self, f, parm0=None) :

		# print error message
		func.format_log_string(self.ENTRY_LOG_MESSAGE, _(f.value))

		return

		if not hasattr(f.value, "code") :
			if f.type == exceptions.IOError :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, \
					_("Can not create file in local."))

				# remote this item from filetransfer status treeview.
				if isinstance(parm0, gtk.TreeIter) :
					self.PANEL_FILETRANSFER_STATUS.remove(treeiter=parm0)
		else :
			if f.value.code == FileTransfer.FX_OK :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("OK"))
			elif f.value.code == FileTransfer.FX_EOF :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("EOF"))
			elif f.value.code == FileTransfer.FX_NO_SUCH_FILE :
				__entry = self.getWidget("entry_directory_remote")
				__entry.set_text(self.CURRENT_DIRECTORY_REMOTE)
				__entry.select_region(0, -1)

				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("No such file."))
			elif f.value.code == FileTransfer.FX_PERMISSION_DENIED :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, \
					_("Permission denied."))
			elif f.value.code == FileTransfer.FX_FAILURE :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("Failed."))
			elif f.value.code == FileTransfer.FX_BAD_MESSAGE :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("Bad message."))
			elif f.value.code == FileTransfer.FX_NO_CONNECTION :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("No connection."))
			elif f.value.code == FileTransfer.FX_CONNECTION_LOST :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("Connection lost."))
			elif f.value.code == FileTransfer.FX_OP_UNSUPPORTED :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, \
					_("Not supported action."))
			else :
				func.format_log_string(self.ENTRY_LOG_MESSAGE, _("Failed."))

	def __eraseLogMessage (self) :
		self.ENTRY_LOG_MESSAGE.set_text("")

		return True

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "FileBrowser.py"


