# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import gtk

import Conf, func, i18n

_ = i18n.gettext()

class Label :

	LABELNAME = ""
	LABELNAME_SHORT = ""
	LABEL_LENGTH = 20
	STATE = None

	EVENTBOX = None

	WITHOUT_CLOSEBUTTON = False

	TAB_POSITION = gtk.POS_BOTTOM
	WIDGET = None

	def __init__ (self, **kwargs) :

		if kwargs.has_key("labelname") :
			self.LABELNAME = kwargs["labelname"]

		if kwargs.has_key("labelname_short") :
			self.LABELNAME_SHORT = kwargs["labelname_short"]

		if kwargs.has_key("without_closebutton") :
			if kwargs["without_closebutton"] :
				self.WITHOUT_CLOSEBUTTON = True

		if not self.LABELNAME_SHORT :
			self.LABELNAME_SHORT = self.LABELNAME

		# set the tab position
		self.WIDGET = gtk.HBox(False, 2)
		self.make()
		self.show()

	def make (self) : pass

	def show (self) :
		self.WIDGET.show()

	def make_labelstring (self, s) :
		labelname = func.get_striped_labelname(s, self.LABEL_LENGTH)
		return labelname

class TabWithClose (Label) :

	def __init__ (self, **kwargs) :

		Label.__init__(self, **kwargs)

	def getWidget (self) :
		return self.WIDGET

	def make (self, labelname=None, labelname_short=None) :
		if labelname :
			self.LABELNAME = labelname
		if labelname_short :
			self.LABELNAME_SHORT = labelname_short

		self.Label = gtk.Label()
		self.Label.set_property("selectable", False)
		self.Label.set_property("use-markup", True)

		self.Label.set_selectable(False)
		self.Label.set_justify(gtk.JUSTIFY_CENTER)
		self.Label.show()

		self.EVENTBOX = gtk.EventBox()
		self.EVENTBOX.add(self.Label)
		self.EVENTBOX.show()

		# make close button
		if not self.WITHOUT_CLOSEBUTTON :
			self.Button = gtk.ToolButton(gtk.STOCK_CLOSE)
			self.Button.show()

		# connect event with method.
		self.EVENTBOX.connect("event", self.on_tab_label)

		# add close button and label in HBOX
		self.WIDGET.pack_start(self.EVENTBOX, False)

		if not self.WITHOUT_CLOSEBUTTON :
			self.WIDGET.pack_end(self.Button, False)

		self.set_label(self.LABELNAME_SHORT)

	def on_tab_label (self, parm1, parm2) :
		__type = parm2.type

		if __type is gtk.gdk.ENTER_NOTIFY :
			if self.LABELNAME == "None" : return
		elif __type is gtk.gdk.LEAVE_NOTIFY :
			pass
		else :
			pass

	def get_label (self) :
		return self.LABELNAME

	TEMPLATE_LABEL = "<span size='small'>%s</span>"
	TEMPLATE_LABEL_ACTIVE = "<span color='red' size='small'>%s</span>"

	def set_label (self, labelname, labelname_short=None) :
		self.LABELNAME = labelname
		if labelname_short :
			self.LABELNAME_SHORT = labelname_short
		else :
			self.LABELNAME_SHORT = self.LABELNAME

		self.Label.set_markup( \
			self.TEMPLATE_LABEL % \
				self.make_labelstring(self.LABELNAME_SHORT) \
		)

		self.set_tooltip()

	def setActive (self, flag=True) :
		if flag :
			__template = self.TEMPLATE_LABEL_ACTIVE
		else :
			__template = self.TEMPLATE_LABEL

		self.Label.set_markup( \
			__template % self.make_labelstring(self.LABELNAME_SHORT) \
		)

	def set_tooltip (self) :
		# add toolip in event box
		__tooltip = gtk.Tooltips()
		__tooltip.set_tip(self.EVENTBOX, self.LABELNAME)
		__tooltip.enable()

class TabWithCloseForVim (TabWithClose) :

	def set_label (self, labelname) :
		self.LABELNAME = labelname
		self.LABELNAME_SHORT = os.path.basename(labelname)

		TabWithClose.set_label(self, self.LABELNAME_SHORT)

		self.set_tooltip()

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Label.py"


