# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import time, gobject
import Conf, func

class SSH :
	METHOD = "get"
	TREESTORE = None
	ITER = None
	REMOTE_FILE = None
	START_TIME = None

	HANDLER_ID_UPDATE = None

	def refreshList (self) :
		pass

	def __init__ (self, method, treestore, iter, filebrowser) :
		self.METHOD = method
		self.TREESTORE = treestore
		self.ITER = iter
		self.FILEBROWSER = filebrowser

	def starting (self, lf, rf, startTime) :
		self.START_TIME = startTime

		if self.METHOD == "get" :
			self.FILE = rf
			self.refreshList = self.FILEBROWSER.listAllLocal()
		elif self.METHOD == "put" :
			self.FILE = lf
			self.refreshList = self.FILEBROWSER.listAllRemote()

		self.HANDLER_ID_UPDATE = gobject.timeout_add(900, self.update)

	def stop (self) :
		gobject.source_remove(self.HANDLER_ID_UPDATE)
		self.HANDLER_ID_UPDATE = None

	def update (self) :
		diff = time.time() - self.START_TIME
		total = self.FILE.total
		speed = total/diff

		if speed > 10000 :
			__str_speed = "%s M/s" % round(speed / 10000)
		elif speed > 1000 :
			__str_speed = "%s K/s" % round(speed / 1000)
		else :
			__str_speed = "%s B/s" % speed

		if speed :
			timeLeft = (self.FILE.size - total) / speed
		else :
			timeLeft = 0

		#(total/self.FILE.size) * 100, \
		#self._abbrevSize(total),
		#self._abbrevSize(total/diff), \
		#self._abbrevTime(timeLeft) \

		try :
			__rate = int(float(total)/float(self.FILE.size) * 100)
		except ZeroDivisionError :
			__rate = 100

		self.TREESTORE.set_value( \
			self.ITER, \
			Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_TIME_LEFT, \
			self._abbrevTime(timeLeft) \
		)

		self.TREESTORE.set_value( \
			self.ITER, \
			Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_PERCENT, \
			"%d%%" % __rate \
		)

		self.TREESTORE.set_value( \
			self.ITER, \
			Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_SPEED, \
			__str_speed \
		)

		if __rate == 100 :
			__pixbuf_direction = self.TREESTORE.get_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_DIRECTION, \
			)

			self.TREESTORE.set_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_DIRECTION, \
				func.change_saturation(__pixbuf_direction, 0.2), \
			)

			__pixbuf_icon = self.TREESTORE.get_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_ICON, \
			)

			self.TREESTORE.set_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_ICON, \
				func.change_saturation(__pixbuf_icon, 0.2), \
			)

			__size = self.TREESTORE.get_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_FILE_SIZE, \
			)

			self.TREESTORE.set_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_FILE_SIZE, \
				"<span foreground=\"grey\">%s</span>" % __size \
			)

			__filename = self.TREESTORE.get_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_FILEPATH, \
			)

			self.TREESTORE.set_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_FILEPATH, \
				"<span foreground=\"grey\">%s</span>" % __filename \
			)

			self.TREESTORE.set_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_SPEED, \
				"<span foreground=\"grey\">0 G/s</span>" \
			)

			self.TREESTORE.set_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_TIME_LEFT, \
				"<span foreground=\"grey\">%s</span>" % self._abbrevTime(timeLeft) \
			)

			self.TREESTORE.set_value( \
				self.ITER, \
				Conf.TREEVIEW_FILE_TRANSFER_STATUS_PANEL_COLUMN_PERCENT, \
				"<span foreground=\"grey\">%d%%</span>" % __rate \
			)

			return False
		else :
			return True

	def _abbrevTime(self, t) :
		if t > 3600: # 1 hour
			hours = int(t / 3600)
			t -= (3600 * hours)
			mins = int(t / 60)
			t -= (60 * mins)
			return "%i:%02i:%02i" % (hours, mins, t)
		else :
			mins = int(t/60)
			t -= (60 * mins)
			return "%02i:%02i" % (mins, t)



"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Progress.py"


