# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import i18n
_ = i18n.gettext()

class List :

	LIST = list()

	def __init__ (self) :
		pass

	def __len__ (self) :
		return len(self.LIST)

	def __iter__ (self) :
		return self.LIST.__iter__()

	def add (self, tab) :
		self.LIST.append(tab)

	def append (self, tab) :
		"""
		depreciated.
		"""
		self.add(tab)

	def remove (self, index) :
		try :
			del(self.LIST[index])
		except IndexError :
			raise IndexError, "%d does not exists in tab-list." % index

	def get (self, index) :
		try :
			return self.LIST[index]
		except IndexError :
			raise IndexError, "%d does not exists in tab-list." % index

	def getChild (self, index) :
		__one = self.get(index)

		return __one.OBJ_CHILD

	def getChildWidget (self, index) :
		__child = self.getChild(index)

		return __child.getWidget()

class History :
	LIST = list()
	NOTEBOOK = None

	def __init__ (self, notebook) :
		self.NOTEBOOK = notebook

	def remember (self, page_number) :
		self.LIST.append(page_number)
		if len(self.LIST) > self.NOTEBOOK.get_n_pages() :
			del(self.LIST[0])

	def goPrevious (self) :
		try :
			__pagenum = self.LIST[-1]
		except IndexError :
			__pagenum = 0
		else :
			del(self.LIST[-1])
			if type(__pagenum) is not int :
				__pagenum = -1

		self.NOTEBOOK.set_current_page(__pagenum)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "TAB.py"

