# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import tempfile, os, pickle, time, sre
import gtk, gobject, shutil, gnome
try :
	from twisted.internet import reactor
except ImportError :
	USE_TWISTED = False
else :
	USE_TWISTED = True

import __VEE__, Conf__, Conf, Accel, i18n, WIDGET, func, State, TAB, Handler, \
	__OS__, Panel, child, Dialog, GNOME, Menu, Widgets, GConf, __PROPERTY__

import i18n
_ = i18n.gettext()

class VEE (WIDGET.WIDGET) :

	STATE_GLOBAL = None
	STATE_LOCAL = None
	GCONF_CLIENT = None

	UID = None
	TAB_HISTORY = None
	TAB_LIST = None

	ACCEL_GROUP_GLOBAL = None
	LIST_TAB_SHORTCUT = dict()

	IS_COMPACT = False
	IS_FULLSCREEN = False
	HANDLER_ID_ADD_NEW_BUTTON = None
	ADD_NEW_BUTTON = None
	ADD_NEW_BUTTON_LABEL = None

	LISTSTORE_EXTERNAL_COMMAND = None

	BOOKMARK = None
	COMMAND = None

	SSH_FILEBROWSER_SHORTCUT_REMOTE = None
	SSH_FILEBROWSER_SHORTCUT_LOCAL = None

	def __init__ (self, state_global, **kwargs) :

		######################################## GET ARGUMENT
		if not isinstance(state_global, State.VEE) :
			raise RuntimeError, "state_global must be given."
		else :
			self.STATE_GLOBAL = state_global

		if kwargs.has_key("args_options") :
			self.ARGS_OPTIONS = kwargs["args_options"]

		if kwargs.has_key("args_args") :
			self.ARGS_ARGS = kwargs["args_args"]

		######################################## get the state info.
		self.__doStateJob()

		############################# load and apply the default font for VEE.
		__fontname_vee = self.GCONF_CLIENT.getValue("vee_font")
		if not __fontname_vee.strip() :
			__fontname_vee = \
				self.GCONF_CLIENT.getValueByPath(Conf.GCONF_GNOME_INTERFACE_FONTNAME)

		gtk.rc_parse_string(Conf.TEMPLATE_RC_FILE % {"fontname" : __fontname_vee})

		######################################## create main window.
		WIDGET.WIDGET.__init__(self, "vee")
		self.STATE_LOCAL.set_value("main-window", self.WIDGET_SELF)

		# start initial module.
		__initial_module = self.GCONF_CLIENT.getValue("initial_module")
		if __initial_module != "None" :
			# When i run this routine without gobject.timeout_add, vte widget could
			# not handle the signal, child-exited, so i wrote like this.
			gobject.timeout_add(1, self.__runInitialModule, __initial_module)

	# INTERNAL METHOD ##################################################
	def __runInitialModule (self, name) :
		self.addPage(name)

		return False

	def __doStateJob (self) :
		######################################## create it's state
		self.STATE_LOCAL = State.VEE()
		self.STATE = {"local": self.STATE_LOCAL, "global": self.STATE_GLOBAL}

		######################################## create it's own uid
		self.UID = func.get_uid()
		self.STATE_GLOBAL.append("list-vee", self.UID)
		self.STATE_LOCAL.set_value("uid", self.UID)

		################################# create state and initialize instances.
		self.GCONF_CLIENT = self.STATE_GLOBAL.get_value("gconf-client")
		self.STATE_LOCAL.set_value("gconf-client", self.GCONF_CLIENT)

		self.TAB_LIST = TAB.List()
		self.STATE_LOCAL.set_value("tab-list", self.TAB_LIST)

		self.BOOKMARK = self.STATE_GLOBAL["bookmark"]
		self.COMMAND = self.STATE_GLOBAL["command"]
		self.SSH_FILEBROWSER_SHORTCUT_LOCAL = self.STATE_GLOBAL["shortcut-local"]

	def __check_environment (self) :
		# If this failed, it will raise RuntimeError.
		__OS__.check_environment( \
			log_directory=self.GCONF_CLIENT.getValue("log_directory"))

		# create tmp directory.
		self.STATE_GLOBAL.set_value( \
			"directory-temp", \
			tempfile.mkdtemp( \
				dir=os.path.join(os.getenv("HOME"), Conf__.DIR_LOCAL, "tmp")) \
		)

	def initialize (self) :

		######################################## check the environment
		self.__check_environment()

		########### "LOGO" image.
		self.getWidget("image5579").set_from_file( \
			os.path.join(Conf__.DIR_PIXMAPS, "vee-logo.png"))

		############ TOOLBAR & MENUBAR.
		if not self.ARGS_OPTIONS.ARG_SHOW_TOOLBAR :
			self.getWidget("toolbar").set_property("visible", False)
		else :
			self.getWidget("toolbar").set_property( \
				"visible", \
				self.GCONF_CLIENT.getValue("show_toolbar") \
			)

		self.getWidget("menubar_main").set_property( \
			"visible", \
			self.GCONF_CLIENT.getValue("show_menubar") \
		)

		############ "COMBOBOX" for external command
		__comboboxentry_external_command = \
			self.getWidget("comboboxentry_external_command")
		__entry_external_command = __comboboxentry_external_command.child

		__entry_external_command.connect("activate", \
			self.on_execute_external_command)

		# set completion.
		__completion = gtk.EntryCompletion()
		__entry_external_command.set_completion(__completion)

		__liststore_external_command = gtk.ListStore(gobject.TYPE_STRING)

		__completion.set_model(__liststore_external_command)
		__completion.set_text_column(0)

		self.STATE_LOCAL.set_value("liststore-external-command", \
			__liststore_external_command)
		self.LISTSTORE_EXTERNAL_COMMAND = __liststore_external_command

		# set treestore.
		__treestore_external_command = gtk.TreeStore(gobject.TYPE_STRING)
		__comboboxentry_external_command.set_model(__treestore_external_command)
		__comboboxentry_external_command.set_text_column(0)

		self.STATE_LOCAL.set_value("treestore-external-command", \
			__liststore_external_command)
		self.TREESTORE_EXTERNAL_COMMAND = __treestore_external_command

		########### "NOTEBOOK"
		self.NOTEBOOK = self.getWidget("notebook")
		self.NOTEBOOK.connect("change-current-page", self.on_handleNotebook)
		self.NOTEBOOK.connect("button-release-event", self.on_button_release_event)

		self.TAB_HISTORY = TAB.History(self.NOTEBOOK)
		self.STATE_LOCAL.set_value("tab-history", self.TAB_HISTORY)

		########### "EVENTBOX"
		#EventBox_Notebook = self.getWidget("eventbox1")
		EVENTBOX_LOGO = self.getWidget("eventbox4")
		EVENTBOX_LOGO.connect("button-release-event", self.on_button_release_event)

		########### "BOOKMARK" PANEL.
		__callback_functions = {"addPage" : self.addPage}

		self.PANEL_BOOKMARK = Panel.Bookmark( \
			self.xml, \
			state=self.STATE, \
			callback_functions=__callback_functions \
		)

		# set bookmark panel toolbar icon size.

		########### "TOOLBAR"
		self.getWidget("toolbar").get_settings().set_property( \
			"gtk-toolbar-icon-size", gtk.ICON_SIZE_SMALL_TOOLBAR)

		# set tooltip in toolbuttons.
		__toolbutton_add_current = self.getWidget("button39")
		__toolbutton_add_category = self.getWidget("button42")
		__toolbutton_property = self.getWidget("button43")
		__toolbutton_remove = self.getWidget("button44")

		#__tooltip = gtk.Tooltips()
		#__tooltip.set_tip(__toolbutton_add_current, _("Add this current tab"))
		#__tooltip.set_tip(__toolbutton_add_category, _("Add new category"))
		#__tooltip.set_tip(__toolbutton_property, _("Edit property"))
		#__tooltip.set_tip(__toolbutton_remove, _("Remove this item"))

		# "ADD NEW CHILD" COMBOBOX.
		self.ADD_NEW_BUTTON = self.getWidget("menutoolbutton1")
		self.ADD_NEW_BUTTON.get_children( \
			)[0].get_children()[0].get_children()[0].set_property("spacing", 5)
		self.ADD_NEW_BUTTON_IMAGE = \
			self.ADD_NEW_BUTTON.get_children( \
				)[0].get_children()[0].get_children()[0].get_children()[0]
		self.ADD_NEW_BUTTON_LABEL = \
			self.ADD_NEW_BUTTON.get_children( \
				)[0].get_children()[0].get_children()[0].get_children()[1]

		self.ADD_NEW_BUTTON_LABEL.set_property("use-markup", True)
		self.ADD_NEW_BUTTON_LABEL.set_label("<span size=\"small\">%s</span>" % _("New"))

		self.HANDLER_ID_ADD_NEW_BUTTON = \
			self.ADD_NEW_BUTTON.connect("clicked", self.on_insert_vim)

		(self.XML_MENU_ADD_NEW, __menu_add_new, ) = WIDGET.get_widget("menu_add_new")
		#__menu_add_new = self.XML_MENU_ADD_NEW.get_widget("menu_add_new")

		# set the image size in menu item
		for __child_name, __child_value in Conf.MENU_ITEM_MAIN.items() :
			__child = self.XML_MENU_ADD_NEW.get_widget( \
				__child_value["widget_name"])

			__child_label = __child.get_children()[0]
			__child_image = __child.get_children()[1]
			__child_label.set_property("use-markup", True)

			__child_image.set_from_stock( \
				__child_value["stock"], gtk.ICON_SIZE_MENU)
			__child_label.set_label( \
				_("<span size=\"small\">%s</span>" % _(__child_value["labelname"])))

		self.ADD_NEW_BUTTON.set_menu(__menu_add_new)

		# connect menuitem with handler
		__child_vim = self.XML_MENU_ADD_NEW.get_widget("child_vim")
		__child_vim.connect("activate", self.on_insert_vim, "from_toolbutton")
		__child_vim_icon = __child_vim.get_image()

		__child_terminal = self.XML_MENU_ADD_NEW.get_widget("child_terminal")
		__child_terminal.connect( \
			"activate", self.on_insert_terminal, "from_toolbutton")

		__child_ssh = self.XML_MENU_ADD_NEW.get_widget("child_ssh")
		if not USE_TWISTED :
			__menu_add_new.remove(__child_ssh)
		else :
			__child_ssh.connect("activate", self.on_insert_ssh, "from_toolbutton")

		__child_ssh_filebrowser = \
			self.XML_MENU_ADD_NEW.get_widget("child_ssh_filebrowser")
		if not USE_TWISTED :
			__menu_add_new.remove(__child_ssh_filebrowser)
		else :
			__child_ssh_filebrowser.connect( \
				"activate", self.on_insert_ssh_filebrowser, "from_toolbutton")

		# set position of paned widget.
		#self.getWidget("vpaned1").compute_position( \
		#	self.getWidget("vpaned1").get_allocation().height, 20, 20)

		# set the state of toggle buttons.
		__togglebutton_menubar = \
			self.getWidget("toggletoolbutton_menubar")
		__togglebutton_bookmark_panel = \
			self.getWidget("toggletoolbutton_bookmark_panel")
		__togglebutton_fullscreen = \
			self.getWidget("toggletoolbutton_fullscreen")

		__togglebutton_menubar.set_active( \
			self.getWidget("menubar_main").get_property("visible"))

		__togglebutton_bookmark_panel.set_active( \
			self.getWidget("vbox59").get_property("visible"))

		__togglebutton_fullscreen.set_active( \
			self.IS_FULLSCREEN)

		__togglebutton_menubar.set_data("handler_id", \
			__togglebutton_menubar.connect( \
				"toggled", self.on_toggle_menubar))

		__togglebutton_bookmark_panel.set_data("handler_id", \
			__togglebutton_bookmark_panel.connect( \
				"toggled", self.on_toggle_bookmark_panel))

		__togglebutton_fullscreen.set_data("handler_id", \
			__togglebutton_fullscreen.connect( \
				"toggled", self.on_toggle_fullscreen))

		# connect signal with toggle button.
		self.getWidget("menubar_main").connect( \
			"hide", \
			self.on_set_toggle_button, \
			__togglebutton_menubar, \
			False \
		)
		self.getWidget("menubar_main").connect( \
			"show", \
			self.on_set_toggle_button, \
			__togglebutton_menubar, \
			True \
		)
		self.getWidget("vbox59").connect( \
			"hide", \
			self.on_set_toggle_button, \
			__togglebutton_bookmark_panel, \
			False \
		)

		self.getWidget("vbox59").connect( \
			"show", \
			self.on_set_toggle_button, \
			__togglebutton_bookmark_panel, \
			True \
		)

		# add additional toolbutton for child, for examples, ssh, ssh filebrowser.
		if USE_TWISTED :
			__buttonbox_additional = self.getWidget("buttonbox_additional")

			for i in Conf.BUTTONLIST_ADDITIONAL :
				b = Widgets.ButtonImage()
				#b.set_relief(gtk.RELIEF_NORMAL)
				b.set_from_stock(i["image"], gtk.ICON_SIZE_MENU)
				b.set_relief(gtk.RELIEF_NONE)
				b.set_tooltip(i["tooltip"])
				b.WIDGET.connect("clicked", eval("self.%s" % i["handler"]))

				__buttonbox_additional.pack_start(b.WIDGET, False)

			__buttonbox_additional.set_property("sensitive", False)

		########### add ACCELERATOR
		self.ACCEL_GROUP_GLOBAL = \
			self.__installAccelGroup(Conf.LIST_KEYBOARD_SHORTCUT)

		########## add signal
		self.WIDGET_SELF.connect("key-press-event", self.on_key_press_event)

		########### add clock
		#self.__updateClock()
		#gobject.timeout_add(1000 * 60, self.__updateClock)

		########### set default focus widget.
		self.getWidget("treeview-bookmark").grab_focus()

		########### restore the latest window geomtry.
		try :
			(w, h, x, y, ) = \
				[ int(i) for i in \
					self.GCONF_CLIENT.getValue("latest_window_geometry").split(",")]
		except ValueError :
			(w, h, x, y, ) = (700, 700, 10, 10, )

		WIDGET.set_window_geometry(self.WIDGET_SELF, (w, h, x, y, ))

		######################################## connect gconf notify
		__notify = GConf.Notify(self.GCONF_CLIENT, self)
		__notify.add()

	# EVENT HANDLER ##################################################
	def __updateClock (self) :
		self.getWidget("label_clock").set_markup( \
			"%s" % func.get_formatted_time(time.time(), "%-I:%M %p %A %F"))

		return True

	def on_about (self, widget) :
		About()

	def on_key_press_event (self, widget, event) :
		__keyname = func.get_keyname(event)

		# run YELP and not send keystroke to childs.
		if __keyname == "F1" :
			self.on_help(None)
			return True

		return False

	def on_button_release_event (self, widget, event) :
		if event.button == 3:
			Menu.on_show_popup_main(widget, event, self, self.STATE)

	def on_handleNotebook (self, notebook, offset) :
		if offset == Conf.NOTEBOOK_REMOVE_OFFSET :
			__buttonbox_additional = self.getWidget("buttonbox_additional")

			if self.NOTEBOOK.get_n_pages() == 0 :
				self.getWidget("image5579").show()
				__buttonbox_additional.set_property("sensitive", False)
			else :
				self.getWidget("image5579").hide()

				__current_page = self.NOTEBOOK.get_current_page()
				try :
					__tab = self.TAB_LIST.get(__current_page)
				except IndexError :
					return

				__egg = __tab.getEgg()
				if __egg.CHILD_TYPE in \
						[child.TYPE_SSH_FILEBROWSER, child.TYPE_SSH, ] :
					__buttonbox_additional.set_property("sensitive", True)
				else :
					__buttonbox_additional.set_property("sensitive", False)

	def on_open_ssh_tab (self, widget) :
		if len(self.TAB_LIST) < 1 : return

		__current_page = self.NOTEBOOK.get_current_page()
		__tab = self.TAB_LIST.get(__current_page)

		__egg = __tab.getEgg()
		if __egg.CHILD_TYPE not in \
				[child.TYPE_SSH_FILEBROWSER, child.TYPE_SSH, ] :
			return

		__data = __egg.getProperties()

		self.addPage("ssh", **__data)

	def on_open_ssh_filebrowser_tab (self, widget) :
		if len(self.TAB_LIST) < 1 : return

		__current_page = self.NOTEBOOK.get_current_page()
		__tab = self.TAB_LIST.get(__current_page)

		__egg = __tab.getEgg()
		if __egg.CHILD_TYPE not in \
				[child.TYPE_SSH_FILEBROWSER, child.TYPE_SSH, ] :
			return

		__data = __egg.getProperties()

		self.addPage("ssh_filebrowser", **__data)

	def nf_update_accel_key (self, client, parm1, entry, parm3) :
		uid = os.path.basename(entry.get_key())

		# get new key and mods.
		__key, __mod = \
			gtk.accelerator_parse(self.GCONF_CLIENT.getValueFromValue(entry.get_value()))

		if not __key or __mod == Conf.NULL_MODIFIER_MASK :
			return self.ACCEL_GROUP_GLOBAL.removeKey(uid)

		return self.ACCEL_GROUP_GLOBAL.updateKey(uid, __key, __mod)

	def on_new_window (self, widget) :
		VEE( \
			self.STATE_GLOBAL, \
			args_options=self.ARGS_OPTIONS, \
			args_args=self.ARGS_ARGS \
		)

	def on_run_external_command_dialog (self, widget) :
		ExternalCommand( \
			state=self.STATE, \
			callback_functions={ \
				"on_execute_external_command" :
				self.on_execute_external_command, \
			} \
		)

	def on_set_toggle_button (self, widget, which, showOrHide=False) :
		__handler_id = which.get_data("handler_id")

		which.handler_block(__handler_id)
		which.set_active(showOrHide)
		which.handler_unblock(__handler_id)

	def on_toggle_toolbar (self, widget) :
		self.__toggleToolbar()

	def on_toggle_menubar (self, widget) :
		self.__toggleMenubar()

	def on_toggle_fullscreen (self, widget) :
		self.__toggleFullScreen()

	def on_toggle_bookmark_panel (self, widget) :
		self.__toggleBookmarkPanel()

	def on_open_file_dialog (self, widget) :
		FileDialog_SelectFileAndDirectory(self, state=self.STATE)

	def on_preferences (self, widget) :
		Preferences(state=self.STATE)

	def on_bookmark_add_current (self, widget) :
		if len(self.TAB_LIST) < 1 : return

		__current_page = self.NOTEBOOK.get_current_page()
		__tab = self.TAB_LIST.get(__current_page)

		# get type, label, label
		__egg = __tab.getEgg()
		if __egg.CHILD_TYPE == child.TYPE_TERMINAL :
			__type = "terminal"
			__label = __egg.getProperty("path")
		elif __egg.CHILD_TYPE == child.TYPE_EXTERNAL_COMMAND :
			__type = "external_command"
			__label = __egg.getProperty("command")
		elif __egg.CHILD_TYPE == child.TYPE_VIM :
			__type = "vim"
			__label = __egg.getProperty("filename")
		elif __egg.CHILD_TYPE == child.TYPE_SSH :
			__type = "ssh"
			__label = "%s@%s" % \
				(__egg.getProperty("user"), __egg.getProperty("host"), )
		elif __egg.CHILD_TYPE == child.TYPE_SSH_FILEBROWSER :
			__type = "ssh_filebrowser"
			__label = "%s@%s" % \
				(__egg.getProperty("user"), __egg.getProperty("host"), )
		else :
			return

		if __label is None or (__label and not __label.strip()) :
			__label = _("New Item")

		__data = __egg.getProperties()
		__data.update({"label" : __label})

		# INSERT DATA. ############################################
		# get parent uid, and find out it's node.
		__treestore, __treeiter = self.PANEL_BOOKMARK.get_selected()
		if not __treeiter :
			__iter_parent = None
		else :
			__iter_parent = __treestore.iter_parent(__treeiter)
			if not __iter_parent :
				__path_parent = tuple()
			else :
				__path_parent = self.PANEL_BOOKMARK.get_path(__iter_parent)

		__uid_parent = self.PANEL_BOOKMARK.getUID(__iter_parent)
		__node_parent = self.BOOKMARK.getNodeByUID(__uid_parent)

		# ADD DATA IN XML #########################################
		__new_node = self.BOOKMARK.addNew(__type, __node_parent)
		self.BOOKMARK.updateValues(__new_node, __data)

		# ADD DATA IN PANEL ########################################3
		# if current item is not category, set the parent category as it's parent.
		if __iter_parent :
			self.PANEL_BOOKMARK.WIDGET_TREEVIEW.expand_row( \
				__path_parent, False)

		__iter = self.PANEL_BOOKMARK.add_row(__new_node, __iter_parent)
		self.PANEL_BOOKMARK.set_editable( \
			__iter, 0, Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_NAME)

	def on_bookmark_add_category(self, widget) :
		# INSERT DATA. ############################################
		# get parent uid, and find out it's node.
		__treestore, __treeiter = self.PANEL_BOOKMARK.get_selected()
		if not __treeiter :
			__iter_parent = None
		else :
			__iter_parent = __treestore.iter_parent(__treeiter)
			if not __iter_parent :
				__path_parent = tuple()
			else :
				__path_parent = self.PANEL_BOOKMARK.get_path(__iter_parent)

		__uid_parent = self.PANEL_BOOKMARK.getUID(__iter_parent)
		__node_parent = self.BOOKMARK.getNodeByUID(__uid_parent)

		# ADD DATA IN XML #########################################
		__new_node = self.BOOKMARK.addNew("category", __node_parent)
		self.BOOKMARK.updateValues(__new_node, {"label" : _("New Category")})

		# ADD DATA IN PANEL ########################################3
		# if current item is not category, set the parent category as it's parent.
		if __iter_parent :
			self.PANEL_BOOKMARK.WIDGET_TREEVIEW.expand_row( \
				__path_parent, False)

		__iter = self.PANEL_BOOKMARK.add_row(__new_node, __iter_parent)
		self.PANEL_BOOKMARK.set_editable( \
			__iter, 0, Conf.TREEVIEW_BOOKMARK_PANEL_COLUMN_NAME)

	def on_bookmark_property(self, widget) :
		__treestore, __treeiter = self.PANEL_BOOKMARK.get_selected()
		if not __treeiter : return

		__uid = self.PANEL_BOOKMARK.getUID(__treeiter)
		if not self.BOOKMARK.getValuesByUID(__uid) : return

		# run the property dialog by it's TYPE.
		__data = self.BOOKMARK.getValuesByUID(__uid)

		__property_window = eval("PROPERTY_%s" % __data["type"].upper())
		__property_window( \
			__uid, panel=self.PANEL_BOOKMARK, state=self.STATE)

		return

	def on_bookmark_remove(self, widget) :
		__treestore, __treeiter = self.PANEL_BOOKMARK.get_selected()
		if not __treeiter : return

		__uid = self.PANEL_BOOKMARK.getUID(__treeiter)

		# remove from xml
		__this_node = self.BOOKMARK.getNodeByUID(__uid)
		__parent_node = self.BOOKMARK.getParent(__this_node)

		if not __parent_node : return
		__parent_node.removeChild(__this_node)

		# remove from panel.
		self.PANEL_BOOKMARK.remove(treeiter=__treeiter)

	def on_quit (self, widget, parm0=None, parm1=None, parm2=None) :
		if len(self.TAB_LIST) > 0 :
			Dialog.AskCloseAllTabDialog( \
				callback_functions={"functions_quit" : self.quitVee})
		else :
			self.quitVee()

		return True

	def on_close (self, widget, parm0=None, parm1=None, parm2=None) :

		current_page = self.NOTEBOOK.get_current_page()

		try :
			self.TAB_LIST.get(current_page).remove_tab()
		except :
			try :
				self.NOTEBOOK.remove_page(current_page)
				self.TAB_LIST.remove(current_page)
			except IndexError :
				pass

			#try :
			#	self.NOTEBOOK.set_current_page(self.TAB_HISTORY.get_previous())
			#except IndexError :
			#	pass

		#self.NOTEBOOK.emit("change-current-page", Conf.NOTEBOOK_REMOVE_OFFSET)

	NOTEBOOK_PAGE_PREVIOUS = None
	def on_notebook_switch_page (self, widget, page, page_num) :

		# refresh window title.
		try :
			__tab_current = self.TAB_LIST.get(page_num)
		except :
			WIDGET.set_title(self.WIDGET_SELF, self.GCONF_CLIENT, _("VEE"))
		else :
			__tab_current.on_change_title(None)

			# ACTIVATE
			__tab_current.activate()

		# DEACTIVATE
		if page_num != self.NOTEBOOK_PAGE_PREVIOUS :
			try :
				__tab_previous = self.TAB_LIST.get(self.NOTEBOOK_PAGE_PREVIOUS)
			except :
				pass
			else :
				__tab_previous.deactivate()

		# remember tab history.
		self.TAB_HISTORY.remember(self.NOTEBOOK_PAGE_PREVIOUS)

		if self.NOTEBOOK.get_n_pages() < 1 :
			self.NOTEBOOK_PAGE_PREVIOUS = None
		else :
			self.NOTEBOOK_PAGE_PREVIOUS = page_num

	def on_execute_external_command (self, entry) :
		__command = entry.get_text()
		if not __command.strip() : return

		self.LISTSTORE_EXTERNAL_COMMAND.append([__command, ])
		self.TREESTORE_EXTERNAL_COMMAND.append(None, [__command, ])

		self.addPage("external_command", **{"external_command": __command})

		entry.set_text("")

	def on_insert_vim (self, widget, parm0=None) :

		if parm0 : self.__changeAddNewButton("vim")
		self.addPage("vim")

	def on_insert_terminal (self, widget, parm0=None) :
		if parm0 : self.__changeAddNewButton("terminal")
		self.addPage("terminal")

	def on_insert_ssh (self, widget, parm0=None) :
		if parm0 : self.__changeAddNewButton("ssh")
		SSHConnection( \
			session_type=Conf.SSH_SESSION_SESSION, \
			state=self.STATE, \
			callback_functions={"addPage": self.addPage} \
		)

		return

	def on_insert_ssh_filebrowser (self, widget, parm0=None) :
		if parm0 : self.__changeAddNewButton("ssh filebrowser")
		SSHConnection( \
			session_type=Conf.SSH_SESSION_SFTP, \
			state=self.STATE, \
			callback_functions={"addPage": self.addPage} \
		)

		return

	def on_help (self, parm1) :
		gnome.help_display(Conf__.INFO["name"])

	# ACCELERATOR METHOD ##################################################
	def ac_dashboard (self, parm1, parm2, parm3, parm4) :

		showSSH = False

		__current_page = self.NOTEBOOK.get_current_page()
		try :
			__tab = self.TAB_LIST.get(__current_page)
		except IndexError :
			pass
		else :
			__egg = __tab.getEgg()
			if __egg.CHILD_TYPE in \
					[child.TYPE_SSH_FILEBROWSER, child.TYPE_SSH, ] :
				showSSH = True

		DashBoard(self, showSSH)
		self.WIDGET_SELF.set_property("sensitive", False)

	def ac_toggle_bookmark (self, parm1, parm2, parm3, parm4) :
		self.__toggleBookmarkPanel()

	def ac_focus_on_external_command (self, parm1, parm2, parm3, parm4) :
		self.getWidget("comboboxentry_external_command").grab_focus()

	def ac_show_tab_list (self, parm1, parm2, parm3, parm4) :
		pass

	def ac_run_on_external_command (self, parm1, parm2, parm3, parm4) :
		pass

	def ac_insert_ssh (self, parm1, parm2, parm3, parm4) :
		SSHConnection( \
			session_type=Conf.SSH_SESSION_SESSION, \
			state=self.STATE, \
			callback_functions={"addPage": self.addPage} \
		)

	def ac_insert_vim (self, parm1, parm2, parm3, parm4) :
		self.addPage("vim")

	def ac_insert_terminal (self, parm1, parm2, parm3, parm4) :
		self.addPage("terminal")

	def ac_change_nth_tab (self, accelgroup, window, keyval, flag) :
		"""
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용.
		"""

		__n = self.LIST_TAB_SHORTCUT[keyval]
		if __n == self.NOTEBOOK.get_current_page() : return

		self.NOTEBOOK.grab_focus()
		self.NOTEBOOK.set_current_page(__n)
		try :
			self.TAB_LIST.getChildWidget(__n).grab_focus()
		except :
			pass

	def ac_next_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.next_page()

	def ac_previous_tab (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.prev_page()

	def ac_font_increase (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.grab_focus()

		__n = self.NOTEBOOK.get_current_page()
		try :
			self.TAB_LIST.getChild(__n).increase_font()
		except :
			return

	def ac_font_decrease (self, parm1, parm2, parm3, parm4) :
		self.NOTEBOOK.grab_focus()

		__n = self.NOTEBOOK.get_current_page()
		try :
			self.TAB_LIST.getChild(__n).decrease_font()
		except :
			return

	def ac_toggle_full_screen (self, widget, parm1, parm2, parm3) :
		self.__toggleFullScreen()

	# ACTION METHOD ##################################################
	def addPage (self, type_child, **kwargs) :
		if self.GCONF_CLIENT.getValueByConf("use_%s" % type_child) is False :
			return

		try :
			__tab = child.getTab(type_child, self.STATE, self.NOTEBOOK, **kwargs)
		except TypeError, msg:
			print func.print_message(msg, "error")
			return

		if __tab.attach() :
			self.NOTEBOOK.emit("change-current-page", Conf.NOTEBOOK_REMOVE_OFFSET)

		self.TAB_LIST.add(__tab)
		self.NOTEBOOK.set_current_page(len(self.TAB_LIST) - 1)

		self.__addAccelKeySwitchTab()

		self.__toggleBookmarkPanel(False)
		__tab.getEggWidget().grab_focus()

		__buttonbox_additional = self.getWidget("buttonbox_additional")
		if type_child in ["ssh", "ssh_filebrowser", ] :
			__buttonbox_additional.set_property("sensitive", True)
		else :
			__buttonbox_additional.set_property("sensitive", False)

	# MISC METHOD ##################################################
	def grab_focus_in_tab (self) :
		__n = self.NOTEBOOK.get_current_page()
		try :
			self.TAB_LIST.getChildWidget(__n).grab_focus()
		except :
			pass

		try :
			__tab = self.TAB_LIST.get(__n)
		except IndexError :
			return

		__buttonbox_additional = self.getWidget("buttonbox_additional")
		__egg = __tab.getEgg()
		if __egg.CHILD_TYPE in \
				[child.TYPE_SSH_FILEBROWSER, child.TYPE_SSH, ] :
			__buttonbox_additional.set_property("sensitive", True)
		else :
			__buttonbox_additional.set_property("sensitive", False)

	def __toggleToolbar (self, force=None) :
		__widget = self.getWidget("toolbar")

		if type(force) is bool :
			__widget.set_property("visible", force)
			return

		__show = __widget.get_property("visible")

		if __show :
			__widget.hide()
		else :
			__widget.show()

	def __toggleMenubar (self, force=None) :
		__widget = self.getWidget("menubar_main")

		if type(force) is bool :
			__widget.set_property("visible", force)
			return

		__show = __widget.get_property("visible")

		if __show :
			__widget.hide()
		else :
			__widget.show()

	def __toggleBookmarkPanel (self, forceShow=None) :
		__panel_bookmark = self.getWidget("vbox59")

		__is_shown = __panel_bookmark.get_property("visible")

		if type(forceShow) is bool :
			__is_shown = not forceShow

		if __is_shown :
			__panel_bookmark.hide()
			self.grab_focus_in_tab()
		else :
			__panel_bookmark.show()

			self.PANEL_BOOKMARK.WIDGET_TREEVIEW.grab_focus()

	def __changeAddNewButton (self, child_name) :
		"""
		change the toolbutton for this child.
		"""
		if not Conf.MENU_ITEM_MAIN.has_key(child_name) :
			return
		else :
			__child = self.XML_MENU_ADD_NEW.get_widget( \
				Conf.MENU_ITEM_MAIN[child_name]["widget_name"])
			(__child_icon_name, __size, ) = __child.get_image().get_stock()

			self.ADD_NEW_BUTTON_IMAGE.set_from_stock( \
				__child_icon_name, gtk.ICON_SIZE_MENU)
			self.ADD_NEW_BUTTON_LABEL.set_label( \
				_("<span size=\"small\">%s</span>" % \
					_(Conf.MENU_ITEM_MAIN[child_name]["labelname"])))

		if self.HANDLER_ID_ADD_NEW_BUTTON :
			self.ADD_NEW_BUTTON.disconnect(self.HANDLER_ID_ADD_NEW_BUTTON)

		self.HANDLER_ID_ADD_NEW_BUTTON = \
			self.ADD_NEW_BUTTON.connect( \
				"clicked", \
				eval("self.%s" % Conf.MENU_ITEM_MAIN[child_name]["handler"]) \
			)

	def checkIsTabs (self) :
		if len(self.TAB_LIST) < 1 :
			return False
		else :
			return True

	def quitVee (self) :

		# remove uid from global state.
		try :
			__index = self.STATE_GLOBAL["list-vee"].index(self.UID)
		except IndexError :
			pass
		except ValueError :
			pass
		else :
			del(self.STATE_GLOBAL["list-vee"][__index])

		try :
			shutil.rmtree(self.STATE_GLOBAL.get_value("directory-temp"))
		except :
			pass

		# save bookmark.
		self.PANEL_BOOKMARK.save_tree_to_xml()
		self.COMMAND.saveXml(Conf.FILE_COMMAND)

		if not self.IS_FULLSCREEN :
			WIDGET.remember_geometry(self.WIDGET_SELF, self.GCONF_CLIENT)

		if USE_TWISTED :
			reactor.stop()
		else :
			gtk.main_quit()

		return True

	def __toggleFullScreen (self) :
		if not self.IS_FULLSCREEN :
			self.WIDGET_SELF.fullscreen()
		else :
			self.WIDGET_SELF.unfullscreen()

		self.IS_FULLSCREEN = not self.IS_FULLSCREEN

		# toggle the fullscreen button.
		__toggle_button = self.getWidget("toggletoolbutton_fullscreen")
		__handler_id = __toggle_button.get_data("handler_id")

		__toggle_button.handler_block(__handler_id)
		__toggle_button.set_active(self.IS_FULLSCREEN)
		__toggle_button.handler_unblock(__handler_id)

	def __addAccelKeySwitchTab (self) :
		"""
		그놈 터미널이나 에피파니처럼 Alt+숫자키로 탭이동하는 패치.
		 - 손경욱(vvs740@nospam@chol.com)님이 보내준 패치를 수정해서 적용
		"""
		__c = Conf.LIST_KEYBOARD_SHORTCUT["keyboard_shortcut_modifier_switch_tab"]

		num = len(self.LIST_TAB_SHORTCUT)
		__accel_key = __c[0] % (num + 1)
		__key, __mod = gtk.accelerator_parse(__accel_key)

		if self.LIST_TAB_SHORTCUT.has_key(__key) :
			return
		else :
			self.LIST_TAB_SHORTCUT[__key] = num
			self.ACCEL_GROUP_GLOBAL.addKey(__accel_key, __key, __mod, eval(__c[1]))

	def __installAccelGroup (self, conf_accel_keys) :
		__GROUP = Accel.Group(self.GCONF_CLIENT)

		for i, j in conf_accel_keys.items() :
			__key, __mod, __callback = __GROUP.getData(i)
			if not __key : continue

			if not __GROUP.addKey(i, __key, __mod, eval(__callback)) :
				raise RuntimeError, "The key, %s was failed to install." % \
					__key
			else :
				# add gconf notification.
				self.GCONF_CLIENT.CLIENT.notify_add( \
					self.GCONF_CLIENT.generatePath(i), \
					self.nf_update_accel_key \
				)

		__GROUP.addToWindow(self.WIDGET_SELF)

		return __GROUP

class SSHConnection (__VEE__.Core, WIDGET.WIDGET) :

	CALLBACK_FUNCTIONS = dict()
	PANEL = None
	SESSION_TYPE = Conf.SSH_SESSION_SESSION

	def __init__ (self, **kwargs) :

		__VEE__.Core.__init__(self, **kwargs)

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		# set the session type, "session" or "sftp"
		if kwargs.has_key("session_type") and \
				kwargs["session_type"] == Conf.SSH_SESSION_SFTP :
			self.SESSION_TYPE = Conf.SSH_SESSION_SFTP
		else :
			self.SESSION_TYPE = Conf.SSH_SESSION_SESSION

		WIDGET.WIDGET.__init__(self, "connection_ssh")

	def initialize (self) :
		# expander.
		self.xml.get_widget("expander4").set_expanded(False)

		__combobox_ssh_version = self.xml.get_widget("combobox5")

		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()
		__cell0.set_property("xalign", 0.0)

		__treestore_ssh_version = gtk.TreeStore(str, str)
		__combobox_ssh_version.set_model(__treestore_ssh_version)

		# add columns to treeview
		__combobox_ssh_version.pack_start(__cell0, False)
		__combobox_ssh_version.set_attributes(__cell0, text=0)

		__treestore_ssh_version.append(None, [_("Version 2"), "2", ])
		__treestore_ssh_version.append(None, [_("Version 1"), "1", ])
		__combobox_ssh_version.set_active(0)

		self.xml.get_widget("entry26").set_text("22")

	def __grab_data (self) :
		__info = dict()

		__info["host"] = self.xml.get_widget("entry23").get_text()
		__info["user"] = self.xml.get_widget("entry24").get_text()

		__combobox_ssh_version = self.xml.get_widget("combobox5")
		__treemodel = __combobox_ssh_version.get_model()
		__info["ssh_version"] = \
			__treemodel.get_value(__combobox_ssh_version.get_active_iter(), 1)

		try :
			__info["port"] = int(self.xml.get_widget("entry26").get_text())
		except ValueError :
			__info["port"] = 22

		if len(self.xml.get_widget("entry27").get_text()) > 0 :
			__info["password"] = self.xml.get_widget("entry27").get_text()

		return __info

	def on_connect (self, widget) :
		__args = self.__grab_data()
		__args_parsed = func.check_uid_data(__args)
		__args.update(__args_parsed)

		if type(__args) is not dict :
			if __args == func.RETVAL_UID_HOST_INVALID : return
			elif __args == func.RETVAL_UID_IP_ADDRESS_INVALID : return
			else :
				return

		__func = self.CALLBACK_FUNCTIONS["addPage"]
		self.on_close(None)

		if self.SESSION_TYPE == Conf.SSH_SESSION_SFTP :
			__func("ssh_filebrowser", **__args)
		else :
			__func("ssh", **__args)

		return False

class PROPERTY_EXTERNAL_COMMAND (__PROPERTY__.VTE) :

	def __init__ (self, uid, **kwargs) :
		__PROPERTY__.VTE.__init__(self, "external_command", uid, **kwargs)

	def initialize (self) :
		self.getWidget("entry3").set_text(self.DATA["external_command"])
		self.getWidget("entry4").set_text(self.DATA["command"])
		self.getWidget("checkbutton3").set_active(\
			self.DATA["external_command_exit_without_enter"])

		__PROPERTY__.VTE.initialize(self)

	##################################################
	# EVENT HANDLER
	def on_external_command_changed_external_command (self, entry) :
		__command = entry.get_text().strip()

		if len(__command) < 1 : return

		self.BOOKMARK.setValue(self.NODE, "external_command", __command)

	def on_external_command_changed_command (self, entry) :
		__command = entry.get_text().strip()

		if len(__command) < 1 : return

		self.BOOKMARK.setValue(self.NODE, "command", __command)

	def on_external_command_exit_without_enter (self, checkbutton) :
		self.BOOKMARK.setValue( \
			self.NODE, \
			"external_command_exit_without_enter", \
			checkbutton.get_active() \
		)

class PROPERTY_SSH_FILEBROWSER (__PROPERTY__.CORE) :

	def __init__ (self, uid, **kwargs) :
		__PROPERTY__.CORE.__init__(self, "ssh_filebrowser", uid, **kwargs)

	def initialize (self) :
		self.getWidget("entry4").set_text(self.DATA["host"])
		self.getWidget("entry5").set_text(self.DATA["user"])
		self.getWidget("entry3").set_text(self.DATA["password"])

		if not str(self.DATA["port"]).strip() :
			__port = "22"
		else :
			try :
				int(self.DATA["port"])
			except ValueError :
				__port = "22"
			else :
				__port = str(self.DATA["port"]).strip()

		self.getWidget("entry6").set_text(__port)

		# set ssh version.
		__combobox_ssh_version = self.xml.get_widget("combobox1")

		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()
		__cell0.set_property("xalign", 0.0)
		__cell1 = gtk.CellRendererText()

		__treestore_ssh_version = gtk.TreeStore(str, str)
		__combobox_ssh_version.set_model(__treestore_ssh_version)

		# add columns to treeview
		__combobox_ssh_version.pack_start(__cell0, False)
		__combobox_ssh_version.set_attributes(__cell0, text=0)

		__treestore_ssh_version.append(None, [_("Version 2"), "2"])
		__treestore_ssh_version.append(None, [_("Version 1"), "1"])
		__combobox_ssh_version.set_active(0)

		__PROPERTY__.CORE.initialize(self)

	##################################################
	# EVENT HANDLER
	def on_ssh_changed_ssh_version (self, combobox) :
		__treemodel = combobox.get_model()
		self.BOOKMARK.setValue( \
			self.NODE, \
			"ssh_version", \
			__treemodel.get_value(combobox.get_active_iter(), 1), \
		)

	def on_ssh_changed_host (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "host", __new)

	def on_ssh_changed_user (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "user", __new)

	def on_ssh_changed_password (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "password", __new)

	def on_ssh_changed_port (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return

		try :
			int(__new)
		except ValueError :
			entry.set_text("22")
			return

		self.BOOKMARK.setValue(self.NODE, "port", __new)

class PROPERTY_SSH (__PROPERTY__.VTE) :

	def __init__ (self, uid, **kwargs) :
		__PROPERTY__.VTE.__init__(self, "ssh", uid, **kwargs)

	def initialize (self) :
		self.getWidget("entry4").set_text(self.DATA["host"])
		self.getWidget("entry5").set_text(self.DATA["user"])
		self.getWidget("entry3").set_text(self.DATA["password"])

		if not str(self.DATA["port"]).strip() :
			__port = "22"
		else :
			try :
				int(self.DATA["port"])
			except ValueError :
				__port = "22"
			else :
				__port = str(self.DATA["port"]).strip()

		self.getWidget("entry6").set_text(__port)

		# set ssh version.
		__combobox_ssh_version = self.xml.get_widget("combobox1")

		# create a CellRenderers to render the data
		__cell0 = gtk.CellRendererText()
		__cell0.set_property("xalign", 0.0)
		__cell1 = gtk.CellRendererText()

		__treestore_ssh_version = gtk.TreeStore(str, str)
		__combobox_ssh_version.set_model(__treestore_ssh_version)

		# add columns to treeview
		__combobox_ssh_version.pack_start(__cell0, False)
		__combobox_ssh_version.set_attributes(__cell0, text=0)

		__treestore_ssh_version.append(None, [_("Version 2"), "2"])
		__treestore_ssh_version.append(None, [_("Version 1"), "1"])
		__combobox_ssh_version.set_active(0)

		__PROPERTY__.VTE.initialize(self)

	##################################################
	# EVENT HANDLER
	def on_ssh_changed_ssh_version (self, combobox) :
		__treemodel = combobox.get_model()
		self.BOOKMARK.setValue( \
			self.NODE, \
			"ssh_version", \
			__treemodel.get_value(combobox.get_active_iter(), 1), \
		)

	def on_ssh_changed_host (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "host", __new)

	def on_ssh_changed_user (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "user", __new)

	def on_ssh_changed_password (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return
		self.BOOKMARK.setValue(self.NODE, "password", __new)

	def on_ssh_changed_port (self, entry) :
		__new = entry.get_text().strip()

		if not __new : return

		try :
			int(__new)
		except ValueError :
			entry.set_text("22")
			return

		self.BOOKMARK.setValue(self.NODE, "port", __new)

class PROPERTY_VIM (__PROPERTY__.VTE) :

	def __init__ (self, uid, **kwargs) :
		__PROPERTY__.VTE.__init__(self, "vim", uid, **kwargs)

	def initialize (self) :
		self.getWidget("filechooserbutton2").set_filename( \
			self.DATA["filename"])

		__PROPERTY__.VTE.initialize(self)

	##################################################
	# EVENT HANDLER
	def on_vim_changed_filename (self, chooser) :
		__new_filename = chooser.get_filename()

		if not __new_filename :
			chooser.set_filename(self.DATA["filename"])
			return

		self.BOOKMARK.setValue(self.NODE, "filename", __new_filename)

	def on_vim_changed_command (self, entry) :
		__command = entry.get_text().strip()

		if len(__command) < 1 : return

		self.BOOKMARK.setValue(self.NODE, "command", __command)

class PROPERTY_TERMINAL (__PROPERTY__.VTE) :

	def __init__ (self, uid, **kwargs) :
		__PROPERTY__.VTE.__init__(self, "terminal", uid, **kwargs)

	def initialize (self) :
		self.getWidget("filechooserbutton2").set_current_folder_uri( \
			self.DATA["path"])
		self.getWidget("entry3").set_text(self.DATA["command"])

		__PROPERTY__.VTE.initialize(self)

	##################################################
	# EVENT HANDLER
	def on_terminal_changed_command (self, entry) :
		__command = entry.get_text().strip()

		if len(__command) < 1 : return

		self.BOOKMARK.setValue(self.NODE, "command", __command)

	def on_terminal_changed_path (self, chooser) :
		__path = chooser.get_filename()

		if not __path :
			chooser.set_uri(self.DATA["path"])
			return

		self.BOOKMARK.setValue(self.NODE, "path", __path)

class PROPERTY_CATEGORY (__PROPERTY__.CORE) :

	PANEL_BOOKMARK = None
	TREEITER = None
	UID = None
	NODE = None
	DATA = None

	def __init__ (self, uid, **kwargs) :
		__PROPERTY__.CORE.__init__(self, "category", uid, **kwargs)

class Preferences (__VEE__.Core, WIDGET.WIDGET) :

	def __init__ (self, **kwargs) :

		__VEE__.Core.__init__(self, **kwargs)

		WIDGET.WIDGET.__init__(self, "preferences")

	##################################################
	# MISC HANDLER
	def initialize (self) :

		self.getWidget("image-preference").set_from_file( \
			os.path.join(Conf__.DIR_PIXMAPS, "vee-logo.png"))
		#self.getWidget("notebook4").remove_page(2)

		Panel.Preference(self.xml, self, state=self.STATE)

		# set fontname for vee. ###########################################
		__fontname_vee = self.GCONF_CLIENT.getValue("vee_font")
		if not __fontname_vee.strip() :
			__fontname_vee = \
				self.GCONF_CLIENT.getValueByPath(Conf.GCONF_GNOME_INTERFACE_FONTNAME)

		self.getWidget("fontbutton1").set_font_name(__fontname_vee)

		# toggle menu/toolbar #############################################
		self.getWidget("checkbutton13").set_active( \
			self.GCONF_CLIENT.getValue("show_menubar"))
		self.getWidget("checkbutton17").set_active( \
			self.GCONF_CLIENT.getValue("show_toolbar"))

		# startup child module. ###########################################
		__combobox_startup = self.getWidget("combobox4")
		child_list = ["None", "VIM", "Terminal", ]
		for i in child_list :
			__combobox_startup.append_text(_(i))

		__initial_module = self.GCONF_CLIENT.getValue("initial_module")
		if __initial_module == "None" :
			__initial_module_index = Conf.COMBOBOX_INITIAL_MODULE_NONE
		elif __initial_module == "vim" :
			__initial_module_index = Conf.COMBOBOX_INITIAL_MODULE_VIM
		elif __initial_module == "terminal" :
			__initial_module_index = Conf.COMBOBOX_INITIAL_MODULE_TERMINAL
		else :
			__initial_module_index = Conf.COMBOBOX_INITIAL_MODULE_NONE

		__combobox_startup.set_active(__initial_module_index)

		# keyboard shortcut #############################################
		Panel.KeyboardShortcutForPreferences(self.xml, state=self.STATE)

	##################################################
	# EVENT HANDLER
	def on_changed_fontname (self, widget) :
		__fontname_vee = widget.get_font_name()
		self.GCONF_CLIENT.setValue("vee_font", __fontname_vee)

	def on_changed_initial_module (self, combobox) :
		if combobox.get_active() == Conf.COMBOBOX_INITIAL_MODULE_NONE :
			__modulename = "None"
		elif combobox.get_active() == Conf.COMBOBOX_INITIAL_MODULE_VIM :
			__modulename = "vim"
		elif combobox.get_active() == Conf.COMBOBOX_INITIAL_MODULE_TERMINAL :
			__modulename = "terminal"
		else :
			return

		self.GCONF_CLIENT.setValue("initial_module", __modulename)

	def on_changed_toggle_toolbar (self, checkbutton) :
		self.GCONF_CLIENT.setValue("show_toolbar", checkbutton.get_active())

	def on_changed_toggle_menubar (self, checkbutton) :
		self.GCONF_CLIENT.setValue("show_menubar", checkbutton.get_active())

class FileDialog_FileLogging (__VEE__.Core, WIDGET.WIDGET) :

	ENTRY = None

	def __init__ (self, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)

		if not kwargs.has_key("entry_filename") :
			raise ValueError, _("entry_filename must be included.")
		else :
			self.ENTRY = kwargs["entry_filename"]

		if not kwargs.has_key("filepath") :
			__filepath = os.getenv("HOME")
		else :
			__filepath = kwargs["filepath"]

		WIDGET.WIDGET.__init__(self, "filechooser_file_logging")

	def initialize (self) :

		if not os.path.isdir(__filepath) :
			__filename = os.path.basename(__filepath)
			self.WIDGET_SELF.set_current_name(__filename)

		self.WIDGET_SELF.set_filename(__filepath)

	def on_open (self, widget) :
		__new = self.WIDGET_SELF.get_filename()

		self.ENTRY.set_text(__new)

		self.on_close(None)

class ExternalCommand (__VEE__.Core, WIDGET.WIDGET) :

	COMMAND = None
	CALLBACK_FUNCTIONS = None
	LISTSTORE = None
	TREESTORE = None

	def __init__ (self, **kwargs) :
		__VEE__.Core.__init__(self, **kwargs)

		self.LISTSTORE = self.STATE_LOCAL["liststore-external-command"]
		self.TREESTORE = self.STATE_LOCAL["treestore-external-command"]

		self.COMMAND = self.STATE_GLOBAL["command"]

		if not kwargs.has_key("callback_functions") :
			raise ValueError, _("callback_functions must be included.")
		else :
			self.CALLBACK_FUNCTIONS = kwargs["callback_functions"]

		WIDGET.WIDGET.__init__(self, "external_command")

	def initialize (self) :

		#################### COMBOBOX ENTRY
		__comboboxentry = self.getWidget("comboboxentry1")
		__entry = __comboboxentry.child

		# set completion
		__completion = gtk.EntryCompletion()
		__completion.set_model(self.LISTSTORE)
		__completion.set_text_column(0)

		__entry.set_completion(__completion)

		# set treestore
		__comboboxentry.set_model(self.TREESTORE)
		__entry.connect("activate", self.on_execute_external_command)

		#################### TREEVIEW
		self.PANEL = Panel.ExternalCommand( \
			self.xml, \
			state=self.STATE, \
			callback_functions={ \
				"on_execute_external_command" :
				self.on_execute_external_command, \
			}
		)

	def on_execute (self, widget) :
		__comboboxentry = self.getWidget("comboboxentry1")
		__entry = __comboboxentry.child

		self.CALLBACK_FUNCTIONS["on_execute_external_command"](__entry)

	def on_execute_external_command (self, widget) :
		__comboboxentry = self.getWidget("comboboxentry1")
		__entry = __comboboxentry.child

		self.CALLBACK_FUNCTIONS["on_execute_external_command"](__entry)

	def on_add_command (self, widget) :
		__command = self.getWidget("comboboxentry1").child.get_text()
		if not __command.strip() : return

		__new_node = self.COMMAND.addNew()
		self.COMMAND.setValue(__new_node, "value", __command)

		self.PANEL.add_row(__new_node)

	def on_remove_command (self, widget) :
		(__store, __iter, ) = self.PANEL.get_selected()
		if not __iter : return

		__uid = self.PANEL.getUID(__iter)

		# remove from xml
		__this_node = self.COMMAND.getNodeByUID(__uid)
		__parent_node = self.COMMAND.getParent(__this_node)

		if not __parent_node : return
		__parent_node.removeChild(__this_node)

		# remove from panel.
		self.PANEL.remove(treeiter=__iter)

		# erase text from combobox entry.
		__comboboxentry = self.getWidget("comboboxentry1")
		__entry = __comboboxentry.child
		__entry.set_text("")

class FileDialog_SelectFileAndDirectory (__VEE__.Core, WIDGET.WIDGET) :

	CURRENT_MODE = Conf.NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_FILE
	FILECHOOSER = None

	def __init__ (self, vee_obj, **kwargs) :

		__VEE__.Core.__init__(self, **kwargs)

		WIDGET.WIDGET.__init__( \
			self, \
			"filechooser_select_file_and_directory" \
		)
		self.addPage = vee_obj.addPage

	def initialize (self) :
		self.FILECHOOSER_FILE = self.getWidget("filechooserwidget4")
		self.FILECHOOSER_DIRECTORY = self.getWidget("filechooserwidget3")

		self.getWidget("entry19").grab_focus()

	# EVENT HANDLER ##################################################
	def on_selected_file (self, widget) :
		__filename = widget.get_filename()
		self.on_close(None)
		self.addPage("vim", filename=__filename)

	def on_file_location (self, entry, event) :
		path = entry.get_text()

		if self.CURRENT_MODE == Conf.NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_FILE :
			__filechooser = self.FILECHOOSER_FILE
		elif self.CURRENT_MODE == Conf.NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_DIRECTORY :
			__filechooser = self.FILECHOOSER_DIRECTORY

		if not __OS__.exists(path) :
			return

		if __OS__.is_file(path) :
			__filechooser.select_filename(path)
		elif __OS__.is_dir(path) :
			__filechooser.set_current_folder(path)

		if func.get_keyname(event) == "Return" :
			if self.CURRENT_MODE == Conf.NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_FILE :
				__filename = __filechooser.get_filename()
				self.on_close(None)
				self.addPage("vim", filename=__filename)
			elif self.CURRENT_MODE == Conf.NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_DIRECTORY :
				__path = __filechooser.get_current_folder()
				self.on_close(None)
				self.addPage("terminal", path=__path)

		return

	on_directory_location = on_file_location

	def on_open (self, widget) :
		if self.CURRENT_MODE == Conf.NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_FILE :
			__filechooser = self.FILECHOOSER_FILE
		elif self.CURRENT_MODE == Conf.NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_DIRECTORY :
			__filechooser = self.FILECHOOSER_DIRECTORY

		if self.CURRENT_MODE == Conf.NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_FILE :
			__filename = __filechooser.get_filename()
			if __filename is None : return

			if __OS__.is_dir(__filename) :
				__filechooser.set_current_folder(__filename)
				return

			self.on_close(None)
			self.addPage("vim", filename=__filename)
		elif self.CURRENT_MODE == Conf.NOTEBOOK_PAGE_FILECHOOSER_SELECT_FILE_AND_DIRECTORY_DIRECTORY :
			__path = __filechooser.get_current_folder()
			if __path is None : return
			self.on_close(None)
			self.addPage("terminal", path=__path)

		return False

	def on_notebook_select_page (self, notebook, page, page_num) :
		self.CURRENT_MODE = page_num

		return

class About (WIDGET.WIDGET) :
	"""
	 "authors"              GValueArray           : Write
	 "comments"             gchararray            : Read / Write
	 "copyright"            gchararray            : Read / Write
	 "documenters"          GValueArray           : Write
	 "logo"                 GdkPixbuf             : Write
	 "name"                 gchararray            : Read / Write
	 "translator-credits"   gchararray            : Read / Write
	 "version"              gchararray            : Read / Write
	"""

	def __init__ (self) :
		WIDGET.WIDGET.__init__(self, "about")

		for i, j in Conf__.INFO.items() :
			self.WIDGET_SELF.set_property(i, _(j))

	def on_ok (self, widget) :
		self.on_close(widget)

class DashBoard (WIDGET.WIDGET) :
	OBJ_VEE = None

	def __init__ (self, obj_vee, showSSH) :
		self.OBJ_VEE = obj_vee
		self.SHOWSSH = showSSH

		WIDGET.WIDGET.__init__(self, "dashboard")

	def initialize (self) :
		self.__toggleSSH(self.SHOWSSH)

		# ASSIGN HANDLER
		__checkbutton_toolbar = self.getWidget("checkbutton16")
		__checkbutton_menubar = self.getWidget("checkbutton15")

		__checkbutton_toolbar.get_children()[0].set_property("use-markup", True)
		__checkbutton_menubar.get_children()[0].set_property("use-markup", True)

		__checkbutton_menubar.set_active( \
			self.OBJ_VEE.getWidget("menubar_main").get_property("visible"))
		__checkbutton_toolbar.set_active( \
			self.OBJ_VEE.getWidget("toolbar").get_property("visible"))

		self.getWidget("label_current_time").set_markup( \
			func.get_formatted_time(time.time(), "%c"))
		gobject.timeout_add(1000, self.updateTime)

		self.getWidget("button47").hide()
		self.getWidget("button48").hide()

	def updateTime (self) :
		__label = self.getWidget("label_current_time")
		if __label is None : return False

		__label.set_markup(func.get_formatted_time(time.time(), "%c"))

		return True

	def __toggleSSH (self, isShow=False) :
		self.getWidget("frame_ssh").set_property("visible", isShow)
		self.getWidget("hseparator_ssh").set_property("visible", isShow)

	# EVENT HANDLER ##################################################
	def on_toggle_menubar (self, widget) :
		self.OBJ_VEE.on_toggle_menubar(None)

	def on_toggle_toolbar (self, widget) :
		self.OBJ_VEE.on_toggle_toolbar(None)

	def on_open_ssh_filebrowser_tab (self, widget) :
		self.OBJ_VEE.on_open_ssh_filebrowser_tab(None)
		self.on_close(None)

	def on_open_ssh_tab (self, widget) :
		self.OBJ_VEE.on_open_ssh_tab(None)
		self.on_close(None)

	def on_insert_vim	 (self, widget) :
		self.OBJ_VEE.on_insert_vim(None)
		self.on_close(None)

	def on_insert_terminal (self, widget) :
		self.OBJ_VEE.on_insert_terminal(None)
		self.on_close(None)

	def on_insert_ssh (self, widget) :
		self.OBJ_VEE.on_insert_ssh(None)
		self.on_close(None)

	def on_insert_ssh_filebrowser (self, widget) :
		self.OBJ_VEE.on_insert_ssh_filebrowser(None)
		self.on_close(None)

	def on_preferences (self, widget) :
		self.OBJ_VEE.on_preferences(None)
		self.on_close(None)

	def on_run_external_command_dialog (self, widget) :
		self.OBJ_VEE.on_run_external_command_dialog(None)
		self.on_close(None)

	def on_close (self, widget) :
		self.OBJ_VEE.WIDGET_SELF.set_property("sensitive", True)
		WIDGET.WIDGET.on_close(self, widget)

class SignalMessage (WIDGET.WIDGET) :

	MESSAGE = None
	TYPE = None

	def __init__ (self, message, type) :
		self.MESSAGE = message
		self.TYPE = type

		WIDGET.WIDGET.__init__(self, "signal_message")

	def initialize (self) :
		if self.MESSAGE :
			__message = self.MESSAGE
			self.getWidget("label_signal_message").set_markup(_(__message))

		__image_widget = self.getWidget("image_signal_type")
		if self.TYPE == "info":
			__image_widget.set_from_stock( \
				gtk.STOCK_DIALOG_INFO, gtk.ICON_SIZE_DIALOG)
		else : # default is 'error'.
			__image_widget.set_from_stock( \
				gtk.STOCK_DIALOG_ERROR, gtk.ICON_SIZE_DIALOG)

"""

Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "Window.py"


