# -*- coding: utf-8 -*-
#    Copyright 2005 Spike^ekipS <spikeekips@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import Conf, Conf__, func

def check_environment (**kwargs) :

	# whether local directory, ~/.gnome/vee.
	if not os.path.isdir(os.path.dirname(Conf.FILE_BOOKMARK)) :
		try :
			os.makedirs(os.path.dirname(Conf.FILE_BOOKMARK))
		except OSError, msg :
			raise RuntimeError, msg

	# check whether temporary directory exists or not.
	if not os.path.isdir(os.path.join(os.getenv("HOME"), Conf__.DIR_LOCAL, "tmp")) :
		try :
			os.makedirs(os.path.join(os.getenv("HOME"), Conf__.DIR_LOCAL, "tmp"))
		except OSError, msg :
			raise RuntimeError, msg

	if kwargs.has_key("log_directory") :
		__directory = os.path.expanduser(kwargs["log_directory"])
		if not os.path.isdir(__directory) :
			try :
				os.makedirs(__directory)
			except OSError, msg :
				raise RuntimeError, msg

def is_valid_command (command) :
	if command.count(os.sep) > 0 :
		if not exists(command) :
			return False
		else :
			return True

	else :
		_i, _o, _e = os.popen3("/usr/bin/which %s" % command)

		if len(_o.readlines()) < 1 :
			return False
		else :
			return True

def escape_path (path) :
	return path.replace( \
		" ", "\\ ").replace( \
		"#", "\\#").replace( \
		"%", "\\%").replace( \
		"(", "\\(").replace( \
		")", "\\)")

import urllib
def get_filename_from_uri (uri) :
	"""
	get the unix file path from uri
	"""

	__a = uri.split(":")
	if len(__a) < 2 : return uri

	slash = sre.compile("^//")
	__b = urllib.url2pathname(slash.sub("", __a[1])).strip()

	return __b

import sre
def parse_command_line_argument (command) :
	parsed_data = { \
		"environment" : tuple(),
		"command" : str(),
		"argument" : tuple(),
	}

	__a = command.split()

	if len(__a) < 2 :
		parsed_data["command"] = command.strip()
		return parsed_data

	q = sre.compile("[A-Z][A-Z_][A-Z_]*=.*") # env

	__env = list()
	__index_env = list()
	for i in range(len(__a)) :
		if q.findall(__a[i]) :
			__env.append(__a[i].strip())
			__index_env.append(i)
		else :
			break

	parsed_data["environment"] = tuple(__env)

	if len(__index_env) > 0 :
		__index = __index_env[-1]
	else :
		__index = -1

	try :
		__command = __a[__index + 1]
	except IndexError :
		return parsed_data

	parsed_data["command"] = __command

	try :
		__argv = __a[__index + 2:]
	except IndexError :
		return parsed_data

	parsed_data["argument"] = tuple(__argv)

	return parsed_data

def normalize_path (path) :
	return os.path.expanduser(path)

def is_valid_pid (pid) :
	if sys.platform == "linux2" :
		__directory_pid = "/proc/%d" % pid
		if not os.path.isdir(__directory_pid) :
			return False
		else :
			return True
	else :
		return True

def get_parent_abs_directory (path) :
	if not os.path.isdir(path) : return None

	return os.path.abspath(os.path.join(path, os.pardir))

def get_parent_directories (path) :
	__path = get_parent_abs_directory(path)
	return get_subdirectories(__path)

def has_parent_directory (path) :
	if not os.path.isdir(path) : return False

	if len(get_parent_abs_directories(path)) < 1 : return False
	else : return True

import sre
def get_dest_filepath (source_filepath, dest_filepath) :
	__dest = os.path.join( \
		dest_filepath, \
		os.path.basename( \
			sre.compile("%s$" % os.sep).sub("", source_filepath) \
		) \
	)

def get_parent_directory (path) :
	return os.sep.join(os.path.dirname("%s/" % path).split(os.sep)[:-1])

def get_subdirectories (path) :
	try :
		return filter(lambda i : os.path.isdir(i), \
			[ os.path.join(path, i)  for i in os.listdir(path) ])
	except OSError :
		return list()

def has_subdirectory (path) :
	if not os.path.isdir(path) : return False

	if len(get_subdirectories(path)) < 1 : return False
	else : return True

def get_pid_by_process_name (name) :
	cmd = "COLUMNS=10000 ps aux | grep \"%s\" | grep -v grep | awk '{print $2}'" % name

	i, o, e = os.popen3(cmd)
	__a = o.readlines()

	if len(__a) != 1 : return None

	try :
		__pid = int(__a[0].strip())
	except ValueError :
		return None

	return __pid

import tempfile
def get_tmp_file (temp_directory=None) :

	if not temp_directory :
		temp_directory = tempfile.mkdtemp(prefix="vee")

	__filename = os.path.join( \
		temp_directory, "%s.tmp" % func.get())

	return __filename

def cleanup_temporary_directory (tmp_directory) :
	for i in glob.glob("%s/*" % tmp_directory) :
		try :
			os.remove(i)
		except OSError :
			continue

import os
def get_real_path_of_command (command) :
	"""
	this is alias of 'which'
	"""
	i,o,e = os.popen3("which %s" % command)

	_b = o.readlines()
	if len(_b) < 1 :
		return None
	else :
		return _b[0]

import time
def get_log_filename (prefix=None) :
	__filename = "%s.log" % time.strftime("%F.%H-%M-%s")

	if prefix :
		prefix = prefix.replace(os.sep, "_")
		__filename = "%s-%s" % (prefix, __filename)

	return __filename

def is_directory_by_st_mode (bin, strictMode=False) :
	import stat
	if bin < stat.S_IFBLK and bin > stat.S_IFDIR :
		return True
	elif not strictMode and bin < stat.S_IFSOCK and bin > stat.S_IFLNK :
		return True
	else :
		return False

def get_filetype_by_st_mode (bin) :
	import stat

	if bin > stat.S_IFSOCK : return stat.S_IFSOCK # socket
	elif bin > stat.S_IFLNK : return stat.S_IFLNK # link
	elif bin > stat.S_IFREG : return stat.S_IFREG # regular file
	elif bin > stat.S_IFBLK : return stat.S_IFBLK # block special device
	elif bin > stat.S_IFDIR : return stat.S_IFDIR # directory
	elif bin > stat.S_IFCHR : return stat.S_IFCHR # character special device
	elif bin > stat.S_IFIFO : return stat.S_IFIFO # named pipe
	else : return stat.S_IFREG

def get_permission_st_mode2oct (bin) :
	return oct(int(bin))[-3:]

def get_permission_oct2str (oct) :

	# check owner
	hextab = { \
		"0" : "0000", "1" : "0001", "2" : "0010", "3" : "0011",
		"4" : "0100", "5" : "0101", "6" : "0110", "7" : "0111",
		"8" : "1000", "9" : "1001", "a" : "1010", "b" : "1011",
		"c" : "1100", "d" : "1101", "e" : "1110", "f" : "1111"
	}

	l = list()
	for i in str(oct) :
		__a = hextab[i]
		if int(__a[1]) == 1 :
			l.append("r")
		else :
			l.append("-")

		if int(__a[2]) == 1 :
			l.append("w")
		else :
			l.append("-")

		if int(__a[3]) == 1 :
			l.append("x")
		else :
			l.append("-")

	return "".join(l)

def get_filesize_as_readable (size=int()) :
	# from http://mail.python.org/pipermail/python-list/1999-December/018395.html
	_abbrevs = [ \
		(1<<50L, "PB"), \
		(1<<40L, "TB"), \
		(1<<30L, "GB"), \
		(1<<20L, "MB"), \
		(1<<10L, "kb"), \
		(1, "B ") \
	]

	for factor, suffix in _abbrevs :
		if size > factor :
			break

	__a = float("%.1f" % float(float(size) / float(factor)))
	__b = int("%d" % (float(size) / float(factor)))

	if ((__a - __b) * 10) < 1 :
		return "%s%s" % (__b, suffix)
	else :
		return "%s%s" % (__a, suffix)

########################################################################
"""
DATA
"""
ERROR_FILE_ALREADY_EXISTS = 10
ERROR_NO_PERMISSION = 20
ERROR_IOERROR = 30
ERROR_NO_SUCH_FILE_OR_DIRECTORY = 40
ERROR_DESTINATION_NO_SUCH_FILE_OR_DIRECTORY = 50
ERROR_OSERROR = 60
ERROR_DESTINATION_IS_FILE = 70
ERROR_OK = 80
########################################################################

os_exists = os.path.exists
os_access = os.access

def exists (name) :
	return os.access(name, os.F_OK)

def is_readable (name) :
	if not exists(name) :
		return False

	return os_access(name, os.R_OK)

def is_writable (name) :
	if not exists(name) :
		return False

	return os_access(name, os.W_OK)

def is_dir (name) :
	if exists(name) :
		return os.path.isdir(name)
	else :
		return False

def is_file (name) :
	if exists(name) :
		return os.path.isfile(name)
	else :
		return False

def mkdir (name) :
	if exists(name) :
		return ERROR_FILE_ALREADY_EXISTS

	if not is_writable(os.path.dirname(name)) :
		return ERROR_NO_PERMISSION

	try :
		os.mkdir(name)
	except IOError, message :
		return IOError

	return True

def remove (filepath) :
	if not exists(filepath) :
		return ERROR_NO_SUCH_FILE_OR_DIRECTORY

	if is_file(filepath) :
		try :
			os.remove(filepath)
		except OSError :
			return ERROR_OSERROR
		else :
			return True

	elif is_dir(filepath) :
		try :
			shutil.rmtree(filepath)
		except OSError :
			return ERROR_OSERROR
		return True
	else :
		try :
			os.remove(filepath)
		except OSError :
			return ERROR_OSERROR
		else :
			return True

	return False

import shutil
def copy (source_filepath, dest_filepath) :

	# if source_filepath does not exists.
	if not __OS__.exists(source_filepath) :
		return ERROR_NO_SUCH_FILE_OR_DIRECTORY

	# if source_filepath is directory
	if __OS__.is_dir(source_filepath) :

		# if dest_filepath does not exists.
		if not __OS__.exists(dest_filepath) :

			# if the parent directory of dest_filepath does not exists,
			__parent = __OS__.get_parent_directory(dest_filepath)
			if not __OS__.exists(__parent) :
				return ERROR_DESTINATION_NO_SUCH_FILE_OR_DIRECTORY
			else :
				if not __OS__.is_writable(__parent) :
					return ERROR_NO_PERMISSION

				try :
					shutil.copytree(source_filepath, dest_filepath)
				except OSError, msg :
					return ERROR_OSERROR
				else :
					return True

		if not __OS__.is_writable(dest_filepath) :
			return ERROR_NO_PERMISSION

		# dest_filepath is directory
		if __OS__.is_dir(dest_filepath) :
			__dest = os.path.join( \
				dest_filepath, \
				os.path.basename( \
					sre.compile("%s$" % os.sep).sub("", source_filepath) \
				) \
			)

			if __OS__.exists(__dest) :
				return ERROR_FILE_ALREADY_EXISTS

			try :
				shutil.copytree(source_filepath, __dest)
			except OSError, msg :
				return ERROR_OSERROR
			else :
				return True

		# dest_filepath is file
		elif __OS__.is_file(dest_filepath) :
			return ERROR_DESTINATION_IS_FILE
		else :
			return False

	# if source_filepath is file
	else :
		# if dest_filepath does not exists.
		if not __OS__.exists(dest_filepath) :

			# if the parent directory of dest_filepath does not exists,
			__parent = __OS__.get_parent_directory(dest_filepath)
			if not __OS__.exists(__parent) :
				return ERROR_DESTINATION_NO_SUCH_FILE_OR_DIRECTORY

			if not __OS__.is_writable(__parent) :
				return ERROR_NO_PERMISSION

			# dest_filepath obviously be file.
			else :
				try :
					shutil.copy(source_filepath, dest_filepath)
				except IOError :
					return ERROR_IOERROR
				else :
					return True

		# dest_filepath obviously be directory.
		elif __OS__.is_dir(dest_filepath) :
			if not __OS__.is_writable(dest_filepath) :
				return ERROR_NO_PERMISSIONcopytree

			__dest = os.path.join( \
				dest_filepath, \
				os.path.basename( \
					sre.compile("%s$" % os.sep).sub("", source_filepath) \
				) \
			)
			if __OS__.exists(__dest) :
				return ERROR_FILE_ALREADY_EXISTS

			try :
				shutil.copy(source_filepath, dest_filepath)
			except IOError :
				return ERROR_IOERROR
			else :
				return True

		elif __OS__.is_file(dest_filepath) :
			return ERROR_FILE_ALREADY_EXISTS

	return False

def move (source_filepath, dest_filepath) :
	# if source_filepath does not exists.
	if not __OS__.exists(source_filepath) :
		return ERROR_NO_SUCH_FILE_OR_DIRECTORY

	# if source_filepath is directory
	if __OS__.is_dir(source_filepath) :
		if __OS__.is_file(dest_filepath) :
			return ERROR_DESTINATION_IS_FILE

		# if dest_filepath does not exists.
		if not __OS__.exists(dest_filepath) :

			# if the parent directory of dest_filepath does not exists,
			__parent = __OS__.get_parent_directory(dest_filepath)
			if not __OS__.exists(__parent) :
				return ERROR_DESTINATION_NO_SUCH_FILE_OR_DIRECTORY
			else :
				if not __OS__.is_writable(__parent) :
					return ERROR_NO_PERMISSION

				try :
					shutil.move(source_filepath, dest_filepath)
				except OSError, msg :
					return ERROR_OSERROR
				else :
					return True

		if not __OS__.is_writable(dest_filepath) :
			return ERROR_NO_PERMISSION

		# dest_filepath obviously be directory.
		if __OS__.is_dir(dest_filepath) :
			__dest = os.path.join( \
				dest_filepath, \
				os.path.basename( \
					sre.compile("%s$" % os.sep).sub("", source_filepath) \
				) \
			)

			if __OS__.exists(__dest) :
				return ERROR_FILE_ALREADY_EXISTS

			try :
				shutil.move(source_filepath, __dest)
			except OSError, msg :
				return ERROR_OSERROR
			else :
				return True

		else :
			return False

	# if source_filepath is file
	else :
		# if dest_filepath does not exists.
		if not __OS__.exists(dest_filepath) :

			# if the parent directory of dest_filepath does not exists,
			__parent = __OS__.get_parent_directory(dest_filepath)
			if not __OS__.exists(__parent) :
				return ERROR_DESTINATION_NO_SUCH_FILE_OR_DIRECTORY

			if not __OS__.is_writable(__parent) :
				return ERROR_NO_PERMISSION

			# dest_filepath obviously be file.
			else :
				try :
					shutil.copy(source_filepath, dest_filepath)
				except IOError :
					return ERROR_IOERROR
				else :
					return True

		# dest_filepath obviously be directory.
		elif __OS__.is_dir(dest_filepath) :
			if not __OS__.is_writable(dest_filepath) :
				return ERROR_NO_PERMISSION

			__dest = os.path.join( \
				dest_filepath, \
				os.path.basename( \
					sre.compile("%s$" % os.sep).sub("", source_filepath) \
				) \
			)
			if __OS__.exists(__dest) :
				return ERROR_FILE_ALREADY_EXISTS

			try :
				shutil.copy(source_filepath, dest_filepath)
			except IOError :
				return ERROR_IOERROR
			else :
				return True

		elif __OS__.is_file(dest_filepath) :
			return ERROR_FILE_ALREADY_EXISTS

	return False

	pass

import sre
def get_new_directory_name (filelist=list()) :
	__name = "New Name" 
	__template = "%s %%s" % __name

	# check whether "New Name" exists or not.
	if not filelist.count(__name) :
		return __name
	else :
		k = [ i for i in filelist \
			if sre.compile( \
				"%s.*[0-9][0-9]*" % __name).findall(os.path.basename(i)) ]

		if len(k) < 1 :
			return __template % 1
		else :
			try :
				suffix = int(k[-1].split()[-1]) + 1
			except ValueError :
				return __template % 1
			else :
				return __template % suffix

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "__OS__.py"


