# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


TYPE_TERMINAL = 1
TYPE_VIM = 2
TYPE_SSH = 3
TYPE_SOCKET = 4
TYPE_EXTERNAL_COMMAND = 5
TYPE_SSH_FILEBROWSER = 6
TYPE_OTHER = -1

import os, sys

import i18n

_ = i18n.gettext()

def getChild (childname) :

	__path = os.path.join(sys.path[0], "child", "%s.py" % childname)

	if not os.path.exists(__path) or not os.path.isfile(__path) :
		raise NameError, _("%s does not installed as CHILD") % childname

	try :
		__module = __import__("child", globals(), locals(), [childname,])
	except ImportError :
		raise ValueError, \
			_("%s is not correctly written child. Please check it.") % childname

	__child_obj = getattr(__module, childname)
	child = getattr(__child_obj, "EGG")
	try :
		__module = __import__("child", globals(), locals(), [childname,])
		__child_obj = getattr(__module, childname)
		child = getattr(__child_obj, "EGG")
	except :
		raise ValueError, \
			_("%s is not correctly written child. Please check it.") % childname

	return child

def getTabObj (childname) :

	__path = os.path.join(sys.path[0], "child", "%s.py" % childname)

	if not os.path.exists(__path) or not os.path.isfile(__path) :
		raise NameError, _("%s does not installed as CHILD") % childname

	try :
		__module = __import__("child", globals(), locals(), [childname,])
		__tab_obj = getattr(__module, childname)
		tab = getattr(__tab_obj, "TAB")
	except :
		raise ValueError, \
			_("%s is not correctly written child. Please check it.")

	return tab

def getTab (childname, state, notebook, **kwargs) :
	child = getChild(childname)
	tab = getTabObj(childname)

	return tab(state, notebook, child, **kwargs)


"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "__init__.py"


