# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, base64, marshal
import child, __VTE__, i18n, __OS__

_ = i18n.gettext()

class EGG (__VTE__.EGG) :

	CHILD_TYPE = child.TYPE_EXTERNAL_COMMAND
	STR_COMMAND_WITH_ENTER = \
"""%s; echo ''; echo \" Press Enter to exit..............\"; read"""

	STR_COMMAND_WITHOUT_ENTER = """%s"""
	EXIT_WITHOUT_ENTER = False

	def __init__ (self, state, **kwargs) :

		__VTE__.EGG.__init__(self, state, **kwargs)

		if not kwargs.has_key("command") :
			raise ValueError, "command must be given."

		if not kwargs.has_key("external_command") :
			raise ValueError, "external_command must be given."

		if self.SETTING.has_key("external-command-exit-without-enter") :
			self.EXIT_WITHOUT_ENTER = \
				self.SETTING["external-command-exit-without-enter"]

	def parse_command (self) :
		if self.EXIT_WITHOUT_ENTER :
			__command = self.STR_COMMAND_WITHOUT_ENTER
		else :
			__command = self.STR_COMMAND_WITH_ENTER

		__argument = ( \
			self.SETTING["command"], \
			"-c", \
			__command % self.SETTING["external_command"], \
		)

		self.setProperty("executive-command", self.SETTING["command"])
		self.setProperty("title", self.SETTING["external_command"])

		return (self.SETTING["command"], __argument, tuple(), os.getcwd())

	def getTitle (self) :
		return self.SETTING["external_command"]

	def attach_popupmenu (self) :
		callback_functions = { \
			"reset" : self.reset, \
			"get_directory" : self.get_directory \
		}

		self.WIDGET.connect( \
			"button-press-event", \
			Menu.on_show_popup_terminal, \
			self.WIDGET, \
			callback_functions \
		)

class TAB (__VTE__.TAB) :

	def getSetting (self) :
		__VTE__.TAB.getSetting(self)

		if not self.SETTING.has_key("command") :
			self.SETTING["command"] = self.GCONF_CLIENT.getValue("terminal_command")

	def createLabel (self, labelname) :

		if self.SETTING.has_key("label") :
			__labelname = self.SETTING["label"]
		else :
			__labelname = self.SETTING["external_command"]

		__VTE__.TAB.createLabel(self, __labelname)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "terminal.py"


