# -*- coding: utf-8 -*-
#    Copyright (C) 2005 Spike^ekipS <spikeekips@gmail.com>
#
#    http://vee.kldp.net
#
#       This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os, base64, marshal
import child, __VTE__, i18n, __OS__

_ = i18n.gettext()

class EGG (__VTE__.EGG) :

	CHILD_TYPE = child.TYPE_TERMINAL
	PATH = ""

	def __init__ (self, state, **kwargs) :
		self.PATH = os.getcwd()
		__VTE__.EGG.__init__(self, state, **kwargs)

	def parse_command (self) :
		(__command, __argument, __environment, __directory, ) = \
			__VTE__.EGG.parse_command(self)

		if not self.SETTING.has_key("path") :
			self.PATH = os.getcwd()
		else :
			self.PATH = self.SETTING["path"]

		return (__command, __argument, __environment, self.PATH, )

	def getTitle (self) :
		__t = __VTE__.EGG.getTitle(self)

		if not __t : return self.PATH

		__t0 = "".join(__t.split(":")[1:]).strip()

		if len(__t0) < 1 :
			__title = __t
		else :
			__title = __t0

		self.setProperty("path", __title)
		return __title

class TAB (__VTE__.TAB) :

	def __init__ (self, state, notebook, child, **kwargs) :

		self.STATE = state
		self.STATE_LOCAL = self.STATE["local"]
		self.STATE_GLOBAL = self.STATE["global"]
		self.GCONF_CLIENT = self.STATE_GLOBAL["gconf-client"]

		# get the latest directory path.
		__VTE__.TAB.__init__(self, state, notebook, child, **kwargs)

		self.OBJ_CHILD.changeEnvironment()

	def getSetting (self) :
		__VTE__.TAB.getSetting(self)

		if not self.SETTING.has_key("command") :
			self.SETTING["command"] = self.GCONF_CLIENT.getValue("terminal_command")

	def createLabel (self, labelname) :

		if self.SETTING.has_key("label") :
			__labelname = self.SETTING["label"]
		elif self.SETTING.has_key("path") :
			__labelname = self.SETTING["path"]
		else :
			__labelname = os.getcwd()

		__VTE__.TAB.createLabel(self, __labelname)

"""
Description
-----------


ChangeLog
---------


Usage
-----


"""

__author__ =  "Spike^ekipS <spikeekips@gmail.com>"
__version__=  "0.1"
__nonsense__ = ""

__file__ = "terminal.py"


